/* DatabaseTable.c generated by valac 0.56.18, the Vala compiler
 * generated from DatabaseTable.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

#define DATABASE_TABLE_SCHEMA_VERSION 24
#define DB_IN_MEMORY_NAME ":memory:"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DATABASE_ERROR (database_error_get_type ())

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
typedef void (*SqliteUserFuncCallback) (sqlite3_context* context, gint values_length1, sqlite3_value** values);
typedef void (*SqliteTraceCallback) (gpointer user_data, const gchar* message);
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
typedef struct _ParamSpecDatabaseTable ParamSpecDatabaseTable;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _ParamSpecDatabaseTable {
	GParamSpec parent_instance;
};

static gpointer database_table_parent_class = NULL;
VALA_EXTERN sqlite3* database_table_db;
sqlite3* database_table_db = NULL;
static gint database_table_in_transaction;
static gint database_table_in_transaction = 0;
static GeeHashMap* database_table_regex_map;
static GeeHashMap* database_table_regex_map = NULL;

VALA_EXTERN GQuark database_error_quark (void);
VALA_EXTERN GType database_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer database_table_ref (gpointer instance);
VALA_EXTERN void database_table_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_database_table (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_database_table (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_database_table (const GValue* value);
VALA_EXTERN GType database_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
static void database_table_regexp_replace (sqlite3_context* context,
                                    sqlite3_value** args,
                                    gint args_length1);
static void database_table_prepare_db (const gchar* filename);
static void _database_table_regexp_replace_sqlite_user_func_callback (sqlite3_context* context,
                                                               gint values_length1,
                                                               sqlite3_value** values);
VALA_EXTERN void app_window_panic (const gchar* msg);
VALA_EXTERN void database_table_on_trace (const gchar* message);
static void _database_table_on_trace_sqlite_trace_callback (gpointer self,
                                                     const gchar* message);
VALA_EXTERN void database_table_init (const gchar* filename);
VALA_EXTERN void database_table_warning (const gchar* op,
                             gint res);
VALA_EXTERN void database_table_terminate (void);
VALA_EXTERN void database_table_fatal (const gchar* op,
                           gint res);
VALA_EXTERN void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
VALA_EXTERN void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
VALA_EXTERN gboolean database_table_exists_by_id (DatabaseTable* self,
                                      gint64 id);
VALA_EXTERN gboolean database_table_select_by_id (DatabaseTable* self,
                                      gint64 id,
                                      const gchar* columns,
                                      sqlite3_stmt** stmt);
static void database_table_prepare_update_by_id (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          sqlite3_stmt** stmt);
static gboolean database_table_execute_update_by_id (DatabaseTable* self,
                                              sqlite3_stmt* stmt);
VALA_EXTERN gboolean database_table_update_text_by_id (DatabaseTable* self,
                                           gint64 id,
                                           const gchar* column,
                                           const gchar* text);
VALA_EXTERN void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
VALA_EXTERN gboolean database_table_update_int_by_id (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint value);
VALA_EXTERN void database_table_update_int_by_id_2 (DatabaseTable* self,
                                        gint64 id,
                                        const gchar* column,
                                        gint value,
                                        GError** error);
VALA_EXTERN gboolean database_table_update_int64_by_id (DatabaseTable* self,
                                            gint64 id,
                                            const gchar* column,
                                            gint64 value);
VALA_EXTERN void database_table_update_int64_by_id_2 (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint64 value,
                                          GError** error);
VALA_EXTERN void database_table_update_double_by_id_2 (DatabaseTable* self,
                                           gint64 id,
                                           const gchar* column,
                                           gdouble value,
                                           GError** error);
VALA_EXTERN void database_table_delete_by_id (DatabaseTable* self,
                                  gint64 id,
                                  GError** error);
VALA_EXTERN gboolean database_table_has_column (const gchar* table_name,
                                    const gchar* column_name);
VALA_EXTERN gboolean database_table_has_table (const gchar* table_name);
VALA_EXTERN gboolean database_table_add_column (const gchar* table_name,
                                    const gchar* column_name,
                                    const gchar* column_constraints);
VALA_EXTERN gboolean database_table_ensure_column (const gchar* table_name,
                                       const gchar* column_name,
                                       const gchar* column_constraints,
                                       const gchar* upgrade_msg);
VALA_EXTERN gint database_table_get_row_count (DatabaseTable* self);
VALA_EXTERN void database_table_begin_transaction (void);
VALA_EXTERN void database_table_commit_transaction (GError** error);
VALA_EXTERN DatabaseTable* database_table_construct (GType object_type);
static void database_table_finalize (DatabaseTable * obj);
static GType database_table_get_type_once (void);

GQuark
database_error_quark (void)
{
	return g_quark_from_static_string ("database-error-quark");
}

static GType
database_error_get_type_once (void)
{
	static const GEnumValue values[] = {{DATABASE_ERROR_ERROR, "DATABASE_ERROR_ERROR", "error"}, {DATABASE_ERROR_BACKING, "DATABASE_ERROR_BACKING", "backing"}, {DATABASE_ERROR_MEMORY, "DATABASE_ERROR_MEMORY", "memory"}, {DATABASE_ERROR_ABORT, "DATABASE_ERROR_ABORT", "abort"}, {DATABASE_ERROR_LIMITS, "DATABASE_ERROR_LIMITS", "limits"}, {DATABASE_ERROR_TYPESPEC, "DATABASE_ERROR_TYPESPEC", "typespec"}, {0, NULL, NULL}};
	GType database_error_type_id;
	database_error_type_id = g_enum_register_static ("DatabaseError", values);
	return database_error_type_id;
}

GType
database_error_get_type (void)
{
	static volatile gsize database_error_type_id__once = 0;
	if (g_once_init_enter (&database_error_type_id__once)) {
		GType database_error_type_id;
		database_error_type_id = database_error_get_type_once ();
		g_once_init_leave (&database_error_type_id__once, database_error_type_id);
	}
	return database_error_type_id__once;
}

static void
database_table_regexp_replace (sqlite3_context* context,
                               sqlite3_value** args,
                               gint args_length1)
{
	gchar* pattern = NULL;
	sqlite3_value* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* text = NULL;
	sqlite3_value* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* replacement = NULL;
	sqlite3_value* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	GRegex* re = NULL;
	GeeHashMap* _tmp13_;
	GeeHashMap* _tmp15_;
	const gchar* _tmp16_;
	GError* _inner_error0_ = NULL;
#line 34 "../src/db/DatabaseTable.vala"
	g_return_if_fail (context != NULL);
#line 35 "../src/db/DatabaseTable.vala"
	_tmp0_ = args[0];
#line 35 "../src/db/DatabaseTable.vala"
	_tmp1_ = (const gchar*) sqlite3_value_text (_tmp0_);
#line 35 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 35 "../src/db/DatabaseTable.vala"
	pattern = _tmp2_;
#line 36 "../src/db/DatabaseTable.vala"
	_tmp3_ = pattern;
#line 36 "../src/db/DatabaseTable.vala"
	if (_tmp3_ == NULL) {
#line 37 "../src/db/DatabaseTable.vala"
		sqlite3_result_error (context, "Missing regular expression", SQLITE_ERROR);
#line 38 "../src/db/DatabaseTable.vala"
		_g_free0 (pattern);
#line 38 "../src/db/DatabaseTable.vala"
		return;
#line 277 "DatabaseTable.c"
	}
#line 41 "../src/db/DatabaseTable.vala"
	_tmp4_ = args[1];
#line 41 "../src/db/DatabaseTable.vala"
	_tmp5_ = (const gchar*) sqlite3_value_text (_tmp4_);
#line 41 "../src/db/DatabaseTable.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 41 "../src/db/DatabaseTable.vala"
	text = _tmp6_;
#line 42 "../src/db/DatabaseTable.vala"
	_tmp7_ = text;
#line 42 "../src/db/DatabaseTable.vala"
	if (_tmp7_ == NULL) {
#line 43 "../src/db/DatabaseTable.vala"
		_g_free0 (text);
#line 43 "../src/db/DatabaseTable.vala"
		_g_free0 (pattern);
#line 43 "../src/db/DatabaseTable.vala"
		return;
#line 297 "DatabaseTable.c"
	}
#line 46 "../src/db/DatabaseTable.vala"
	_tmp8_ = args[2];
#line 46 "../src/db/DatabaseTable.vala"
	_tmp9_ = (const gchar*) sqlite3_value_text (_tmp8_);
#line 46 "../src/db/DatabaseTable.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 46 "../src/db/DatabaseTable.vala"
	replacement = _tmp10_;
#line 47 "../src/db/DatabaseTable.vala"
	_tmp11_ = replacement;
#line 47 "../src/db/DatabaseTable.vala"
	if (_tmp11_ == NULL) {
#line 311 "DatabaseTable.c"
		sqlite3_value* _tmp12_;
#line 48 "../src/db/DatabaseTable.vala"
		_tmp12_ = args[1];
#line 48 "../src/db/DatabaseTable.vala"
		sqlite3_result_value (context, _tmp12_);
#line 49 "../src/db/DatabaseTable.vala"
		_g_free0 (replacement);
#line 49 "../src/db/DatabaseTable.vala"
		_g_free0 (text);
#line 49 "../src/db/DatabaseTable.vala"
		_g_free0 (pattern);
#line 49 "../src/db/DatabaseTable.vala"
		return;
#line 325 "DatabaseTable.c"
	}
#line 53 "../src/db/DatabaseTable.vala"
	_tmp13_ = database_table_regex_map;
#line 53 "../src/db/DatabaseTable.vala"
	if (_tmp13_ == NULL) {
#line 331 "DatabaseTable.c"
		GeeHashMap* _tmp14_;
#line 54 "../src/db/DatabaseTable.vala"
		_tmp14_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_REGEX, (GBoxedCopyFunc) g_regex_ref, (GDestroyNotify) g_regex_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 54 "../src/db/DatabaseTable.vala"
		_g_object_unref0 (database_table_regex_map);
#line 54 "../src/db/DatabaseTable.vala"
		database_table_regex_map = _tmp14_;
#line 339 "DatabaseTable.c"
	}
#line 56 "../src/db/DatabaseTable.vala"
	_tmp15_ = database_table_regex_map;
#line 56 "../src/db/DatabaseTable.vala"
	_tmp16_ = pattern;
#line 56 "../src/db/DatabaseTable.vala"
	if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp16_)) {
#line 347 "DatabaseTable.c"
		GeeHashMap* _tmp17_;
		const gchar* _tmp18_;
		gpointer _tmp19_;
#line 57 "../src/db/DatabaseTable.vala"
		_tmp17_ = database_table_regex_map;
#line 57 "../src/db/DatabaseTable.vala"
		_tmp18_ = pattern;
#line 57 "../src/db/DatabaseTable.vala"
		_tmp19_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp18_);
#line 57 "../src/db/DatabaseTable.vala"
		_g_regex_unref0 (re);
#line 57 "../src/db/DatabaseTable.vala"
		re = (GRegex*) _tmp19_;
#line 361 "DatabaseTable.c"
	} else {
		{
			GRegex* _tmp20_ = NULL;
			const gchar* _tmp21_;
			GRegex* _tmp22_;
			GRegex* _tmp23_;
			GeeHashMap* _tmp24_;
			const gchar* _tmp25_;
			GRegex* _tmp26_;
#line 60 "../src/db/DatabaseTable.vala"
			_tmp21_ = pattern;
#line 60 "../src/db/DatabaseTable.vala"
			_tmp22_ = g_regex_new (_tmp21_, G_REGEX_DEFAULT, G_REGEX_MATCH_DEFAULT, &_inner_error0_);
#line 60 "../src/db/DatabaseTable.vala"
			_tmp20_ = _tmp22_;
#line 60 "../src/db/DatabaseTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 379 "DatabaseTable.c"
				goto __catch0_g_error;
			}
#line 60 "../src/db/DatabaseTable.vala"
			_tmp23_ = _tmp20_;
#line 60 "../src/db/DatabaseTable.vala"
			_tmp20_ = NULL;
#line 60 "../src/db/DatabaseTable.vala"
			_g_regex_unref0 (re);
#line 60 "../src/db/DatabaseTable.vala"
			re = _tmp23_;
#line 61 "../src/db/DatabaseTable.vala"
			_tmp24_ = database_table_regex_map;
#line 61 "../src/db/DatabaseTable.vala"
			_tmp25_ = pattern;
#line 61 "../src/db/DatabaseTable.vala"
			_tmp26_ = re;
#line 61 "../src/db/DatabaseTable.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp25_, _tmp26_);
#line 59 "../src/db/DatabaseTable.vala"
			_g_regex_unref0 (_tmp20_);
#line 400 "DatabaseTable.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp27_;
			const gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
#line 59 "../src/db/DatabaseTable.vala"
			err = _inner_error0_;
#line 59 "../src/db/DatabaseTable.vala"
			_inner_error0_ = NULL;
#line 63 "../src/db/DatabaseTable.vala"
			_tmp27_ = err;
#line 63 "../src/db/DatabaseTable.vala"
			_tmp28_ = _tmp27_->message;
#line 63 "../src/db/DatabaseTable.vala"
			_tmp29_ = g_strdup_printf ("Invalid pattern: %s", _tmp28_);
#line 63 "../src/db/DatabaseTable.vala"
			_tmp30_ = _tmp29_;
#line 63 "../src/db/DatabaseTable.vala"
			sqlite3_result_error (context, _tmp30_, SQLITE_ERROR);
#line 63 "../src/db/DatabaseTable.vala"
			_g_free0 (_tmp30_);
#line 64 "../src/db/DatabaseTable.vala"
			_g_error_free0 (err);
#line 64 "../src/db/DatabaseTable.vala"
			_g_regex_unref0 (re);
#line 64 "../src/db/DatabaseTable.vala"
			_g_free0 (replacement);
#line 64 "../src/db/DatabaseTable.vala"
			_g_free0 (text);
#line 64 "../src/db/DatabaseTable.vala"
			_g_free0 (pattern);
#line 64 "../src/db/DatabaseTable.vala"
			return;
#line 438 "DatabaseTable.c"
		}
		__finally0:
#line 59 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 59 "../src/db/DatabaseTable.vala"
			_g_regex_unref0 (re);
#line 59 "../src/db/DatabaseTable.vala"
			_g_free0 (replacement);
#line 59 "../src/db/DatabaseTable.vala"
			_g_free0 (text);
#line 59 "../src/db/DatabaseTable.vala"
			_g_free0 (pattern);
#line 59 "../src/db/DatabaseTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 59 "../src/db/DatabaseTable.vala"
			g_clear_error (&_inner_error0_);
#line 59 "../src/db/DatabaseTable.vala"
			return;
#line 457 "DatabaseTable.c"
		}
	}
	{
		gchar* _result_ = NULL;
		GRegex* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp36_;
		GDestroyNotify _tmp37_;
#line 69 "../src/db/DatabaseTable.vala"
		_tmp31_ = re;
#line 69 "../src/db/DatabaseTable.vala"
		_tmp32_ = text;
#line 69 "../src/db/DatabaseTable.vala"
		_tmp33_ = replacement;
#line 69 "../src/db/DatabaseTable.vala"
		_tmp34_ = g_regex_replace (_tmp31_, _tmp32_, (gssize) -1, 0, _tmp33_, G_REGEX_MATCH_DEFAULT, &_inner_error0_);
#line 69 "../src/db/DatabaseTable.vala"
		_result_ = _tmp34_;
#line 69 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 481 "DatabaseTable.c"
			goto __catch1_g_error;
		}
#line 70 "../src/db/DatabaseTable.vala"
		_tmp35_ = _result_;
#line 70 "../src/db/DatabaseTable.vala"
		_tmp36_ = g_strdup (_tmp35_);
#line 70 "../src/db/DatabaseTable.vala"
		_tmp37_ = g_free;
#line 70 "../src/db/DatabaseTable.vala"
		sqlite3_result_text (context, _tmp36_, -1, _tmp37_);
#line 68 "../src/db/DatabaseTable.vala"
		_g_free0 (_result_);
#line 494 "DatabaseTable.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		GError* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
#line 68 "../src/db/DatabaseTable.vala"
		err = _inner_error0_;
#line 68 "../src/db/DatabaseTable.vala"
		_inner_error0_ = NULL;
#line 72 "../src/db/DatabaseTable.vala"
		_tmp38_ = err;
#line 72 "../src/db/DatabaseTable.vala"
		_tmp39_ = _tmp38_->message;
#line 72 "../src/db/DatabaseTable.vala"
		_tmp40_ = g_strdup_printf ("Replacement failed: %s", _tmp39_);
#line 72 "../src/db/DatabaseTable.vala"
		_tmp41_ = _tmp40_;
#line 72 "../src/db/DatabaseTable.vala"
		sqlite3_result_error (context, _tmp41_, SQLITE_ERROR);
#line 72 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp41_);
#line 68 "../src/db/DatabaseTable.vala"
		_g_error_free0 (err);
#line 522 "DatabaseTable.c"
	}
	__finally1:
#line 68 "../src/db/DatabaseTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../src/db/DatabaseTable.vala"
		_g_regex_unref0 (re);
#line 68 "../src/db/DatabaseTable.vala"
		_g_free0 (replacement);
#line 68 "../src/db/DatabaseTable.vala"
		_g_free0 (text);
#line 68 "../src/db/DatabaseTable.vala"
		_g_free0 (pattern);
#line 68 "../src/db/DatabaseTable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 68 "../src/db/DatabaseTable.vala"
		g_clear_error (&_inner_error0_);
#line 68 "../src/db/DatabaseTable.vala"
		return;
#line 541 "DatabaseTable.c"
	}
#line 34 "../src/db/DatabaseTable.vala"
	_g_regex_unref0 (re);
#line 34 "../src/db/DatabaseTable.vala"
	_g_free0 (replacement);
#line 34 "../src/db/DatabaseTable.vala"
	_g_free0 (text);
#line 34 "../src/db/DatabaseTable.vala"
	_g_free0 (pattern);
#line 551 "DatabaseTable.c"
}

static void
_database_table_regexp_replace_sqlite_user_func_callback (sqlite3_context* context,
                                                          gint values_length1,
                                                          sqlite3_value** values)
{
#line 84 "../src/db/DatabaseTable.vala"
	database_table_regexp_replace (context, values, values_length1);
#line 561 "DatabaseTable.c"
}

static void
_database_table_on_trace_sqlite_trace_callback (gpointer self,
                                                const gchar* message)
{
#line 108 "../src/db/DatabaseTable.vala"
	database_table_on_trace (message);
#line 570 "DatabaseTable.c"
}

static void
database_table_prepare_db (const gchar* filename)
{
	gint res = 0;
	sqlite3* _tmp0_ = NULL;
	gint _tmp1_;
	sqlite3* _tmp2_;
	const gchar* sql_debug = NULL;
	const gchar* _tmp15_;
	gboolean _tmp16_ = FALSE;
	const gchar* _tmp17_;
	GError* _inner_error0_ = NULL;
#line 79 "../src/db/DatabaseTable.vala"
	g_return_if_fail (filename != NULL);
#line 81 "../src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_open_v2 (filename, &_tmp0_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
#line 81 "../src/db/DatabaseTable.vala"
	_sqlite3_close0 (database_table_db);
#line 81 "../src/db/DatabaseTable.vala"
	database_table_db = _tmp0_;
#line 81 "../src/db/DatabaseTable.vala"
	res = _tmp1_;
#line 84 "../src/db/DatabaseTable.vala"
	_tmp2_ = database_table_db;
#line 84 "../src/db/DatabaseTable.vala"
	sqlite3_create_function (_tmp2_, "regexp_replace", 3, SQLITE_UTF8 | SQLITE_DETERMINISTIC, NULL, _database_table_regexp_replace_sqlite_user_func_callback, NULL, NULL);
#line 87 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_OK) {
#line 601 "DatabaseTable.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 88 "../src/db/DatabaseTable.vala"
		_tmp3_ = g_strdup_printf (_ ("Unable to open/create photo database %s: error code %d"), filename, res);
#line 88 "../src/db/DatabaseTable.vala"
		_tmp4_ = _tmp3_;
#line 88 "../src/db/DatabaseTable.vala"
		app_window_panic (_tmp4_);
#line 88 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp4_);
#line 612 "DatabaseTable.c"
	}
#line 92 "../src/db/DatabaseTable.vala"
	if (g_strcmp0 (filename, DB_IN_MEMORY_NAME) != 0) {
#line 616 "DatabaseTable.c"
		{
			GFile* file_db = NULL;
			GFile* _tmp5_;
			GFileInfo* info = NULL;
			GFile* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
#line 94 "../src/db/DatabaseTable.vala"
			_tmp5_ = g_file_new_for_path (filename);
#line 94 "../src/db/DatabaseTable.vala"
			file_db = _tmp5_;
#line 95 "../src/db/DatabaseTable.vala"
			_tmp6_ = file_db;
#line 95 "../src/db/DatabaseTable.vala"
			_tmp7_ = g_file_query_info (_tmp6_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 95 "../src/db/DatabaseTable.vala"
			info = _tmp7_;
#line 95 "../src/db/DatabaseTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 95 "../src/db/DatabaseTable.vala"
				_g_object_unref0 (file_db);
#line 638 "DatabaseTable.c"
				goto __catch0_g_error;
			}
#line 96 "../src/db/DatabaseTable.vala"
			_tmp8_ = info;
#line 96 "../src/db/DatabaseTable.vala"
			if (!g_file_info_get_attribute_boolean (_tmp8_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE)) {
#line 645 "DatabaseTable.c"
				gchar* _tmp9_;
				gchar* _tmp10_;
#line 97 "../src/db/DatabaseTable.vala"
				_tmp9_ = g_strdup_printf (_ ("Unable to write to photo database file:\n %s"), filename);
#line 97 "../src/db/DatabaseTable.vala"
				_tmp10_ = _tmp9_;
#line 97 "../src/db/DatabaseTable.vala"
				app_window_panic (_tmp10_);
#line 97 "../src/db/DatabaseTable.vala"
				_g_free0 (_tmp10_);
#line 656 "DatabaseTable.c"
			}
#line 93 "../src/db/DatabaseTable.vala"
			_g_object_unref0 (info);
#line 93 "../src/db/DatabaseTable.vala"
			_g_object_unref0 (file_db);
#line 662 "DatabaseTable.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 93 "../src/db/DatabaseTable.vala"
			e = _inner_error0_;
#line 93 "../src/db/DatabaseTable.vala"
			_inner_error0_ = NULL;
#line 99 "../src/db/DatabaseTable.vala"
			_tmp11_ = e;
#line 99 "../src/db/DatabaseTable.vala"
			_tmp12_ = _tmp11_->message;
#line 99 "../src/db/DatabaseTable.vala"
			_tmp13_ = g_strdup_printf (_ ("Error accessing database file:\n %s\n\nError was: \n%s"), filename, _tmp12_);
#line 99 "../src/db/DatabaseTable.vala"
			_tmp14_ = _tmp13_;
#line 99 "../src/db/DatabaseTable.vala"
			app_window_panic (_tmp14_);
#line 99 "../src/db/DatabaseTable.vala"
			_g_free0 (_tmp14_);
#line 93 "../src/db/DatabaseTable.vala"
			_g_error_free0 (e);
#line 690 "DatabaseTable.c"
		}
		__finally0:
#line 93 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 93 "../src/db/DatabaseTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 93 "../src/db/DatabaseTable.vala"
			g_clear_error (&_inner_error0_);
#line 93 "../src/db/DatabaseTable.vala"
			return;
#line 701 "DatabaseTable.c"
		}
	}
#line 104 "../src/db/DatabaseTable.vala"
	_tmp15_ = g_getenv ("SHOTWELL_SQL_DEBUG");
#line 104 "../src/db/DatabaseTable.vala"
	sql_debug = _tmp15_;
#line 107 "../src/db/DatabaseTable.vala"
	_tmp17_ = sql_debug;
#line 107 "../src/db/DatabaseTable.vala"
	if (_tmp17_ != NULL) {
#line 712 "DatabaseTable.c"
		const gchar* _tmp18_;
#line 107 "../src/db/DatabaseTable.vala"
		_tmp18_ = sql_debug;
#line 107 "../src/db/DatabaseTable.vala"
		_tmp16_ = g_strcmp0 (_tmp18_, "") != 0;
#line 718 "DatabaseTable.c"
	} else {
#line 107 "../src/db/DatabaseTable.vala"
		_tmp16_ = FALSE;
#line 722 "DatabaseTable.c"
	}
#line 107 "../src/db/DatabaseTable.vala"
	if (_tmp16_) {
#line 726 "DatabaseTable.c"
		sqlite3* _tmp19_;
#line 108 "../src/db/DatabaseTable.vala"
		_tmp19_ = database_table_db;
#line 108 "../src/db/DatabaseTable.vala"
		sqlite3_trace (_tmp19_, _database_table_on_trace_sqlite_trace_callback, NULL);
#line 732 "DatabaseTable.c"
	}
}

void
database_table_on_trace (const gchar* message)
{
#line 112 "../src/db/DatabaseTable.vala"
	g_return_if_fail (message != NULL);
#line 113 "../src/db/DatabaseTable.vala"
	g_debug ("DatabaseTable.vala:113: SQLITE: %s", message);
#line 743 "DatabaseTable.c"
}

static gint
_sqlite3_exec (sqlite3* self,
               const gchar* sql,
               sqlite3_callback callback,
               gpointer callback_target,
               gchar** errmsg)
{
	gchar* _vala_errmsg = NULL;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* _tmp4_;
	gint result;
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "sqlite3.vapi"
	_tmp1_ = sqlite3_exec (self, sql, callback, callback_target, (char**) (&_tmp0_));
#line 36 "sqlite3.vapi"
	sqlite_errmsg = _tmp0_;
#line 36 "sqlite3.vapi"
	ec = _tmp1_;
#line 37 "sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 772 "DatabaseTable.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 38 "sqlite3.vapi"
		_tmp2_ = sqlite_errmsg;
#line 38 "sqlite3.vapi"
		_tmp3_ = g_strdup (_tmp2_);
#line 38 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "sqlite3.vapi"
		_vala_errmsg = _tmp3_;
#line 783 "DatabaseTable.c"
	} else {
#line 40 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 40 "sqlite3.vapi"
		_vala_errmsg = NULL;
#line 789 "DatabaseTable.c"
	}
#line 42 "sqlite3.vapi"
	_tmp4_ = sqlite_errmsg;
#line 42 "sqlite3.vapi"
	sqlite3_free ((void*) _tmp4_);
#line 43 "sqlite3.vapi"
	result = ec;
#line 43 "sqlite3.vapi"
	if (errmsg) {
#line 43 "sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 801 "DatabaseTable.c"
	} else {
#line 43 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 805 "DatabaseTable.c"
	}
#line 43 "sqlite3.vapi"
	return result;
#line 809 "DatabaseTable.c"
}

void
database_table_init (const gchar* filename)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 116 "../src/db/DatabaseTable.vala"
	g_return_if_fail (filename != NULL);
#line 118 "../src/db/DatabaseTable.vala"
	database_table_prepare_db (filename);
#line 122 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 122 "../src/db/DatabaseTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS VersionTable (" "id INTEGER PRIMARY KEY, " "schema_version INTEGER, " "app_version TEXT, " "user_data TEXT NULL" ")", -1, &_tmp1_, NULL);
#line 122 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 122 "../src/db/DatabaseTable.vala"
	stmt = _tmp1_;
#line 122 "../src/db/DatabaseTable.vala"
	res = _tmp2_;
#line 130 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_OK) {
#line 838 "DatabaseTable.c"
		gchar* backup_path = NULL;
		gchar* _tmp3_;
#line 131 "../src/db/DatabaseTable.vala"
		_sqlite3_close0 (database_table_db);
#line 131 "../src/db/DatabaseTable.vala"
		database_table_db = NULL;
#line 133 "../src/db/DatabaseTable.vala"
		_tmp3_ = g_strconcat (filename, ".bak", NULL);
#line 133 "../src/db/DatabaseTable.vala"
		backup_path = _tmp3_;
#line 849 "DatabaseTable.c"
		{
			GFile* src = NULL;
			const gchar* _tmp4_;
			GFile* _tmp5_;
			GFile* dest = NULL;
			GFile* _tmp6_;
			GFile* _tmp7_;
			GFile* _tmp8_;
#line 136 "../src/db/DatabaseTable.vala"
			_tmp4_ = backup_path;
#line 136 "../src/db/DatabaseTable.vala"
			_tmp5_ = g_file_new_for_commandline_arg (_tmp4_);
#line 136 "../src/db/DatabaseTable.vala"
			src = _tmp5_;
#line 137 "../src/db/DatabaseTable.vala"
			_tmp6_ = g_file_new_for_commandline_arg (filename);
#line 137 "../src/db/DatabaseTable.vala"
			dest = _tmp6_;
#line 138 "../src/db/DatabaseTable.vala"
			_tmp7_ = src;
#line 138 "../src/db/DatabaseTable.vala"
			_tmp8_ = dest;
#line 138 "../src/db/DatabaseTable.vala"
			g_file_copy (_tmp7_, _tmp8_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_ALL_METADATA, NULL, NULL, NULL, &_inner_error0_);
#line 138 "../src/db/DatabaseTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 138 "../src/db/DatabaseTable.vala"
				_g_object_unref0 (dest);
#line 138 "../src/db/DatabaseTable.vala"
				_g_object_unref0 (src);
#line 880 "DatabaseTable.c"
				goto __catch0_g_error;
			}
#line 141 "../src/db/DatabaseTable.vala"
			database_table_prepare_db (filename);
#line 135 "../src/db/DatabaseTable.vala"
			_g_object_unref0 (dest);
#line 135 "../src/db/DatabaseTable.vala"
			_g_object_unref0 (src);
#line 889 "DatabaseTable.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _error_ = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 135 "../src/db/DatabaseTable.vala"
			_error_ = _inner_error0_;
#line 135 "../src/db/DatabaseTable.vala"
			_inner_error0_ = NULL;
#line 143 "../src/db/DatabaseTable.vala"
			_tmp9_ = _error_;
#line 143 "../src/db/DatabaseTable.vala"
			_tmp10_ = _tmp9_->message;
#line 143 "../src/db/DatabaseTable.vala"
			_tmp11_ = g_strdup_printf (_ ("Unable to restore photo database %s"), _tmp10_);
#line 143 "../src/db/DatabaseTable.vala"
			_tmp12_ = _tmp11_;
#line 143 "../src/db/DatabaseTable.vala"
			app_window_panic (_tmp12_);
#line 143 "../src/db/DatabaseTable.vala"
			_g_free0 (_tmp12_);
#line 135 "../src/db/DatabaseTable.vala"
			_g_error_free0 (_error_);
#line 917 "DatabaseTable.c"
		}
		__finally0:
#line 135 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 135 "../src/db/DatabaseTable.vala"
			_g_free0 (backup_path);
#line 135 "../src/db/DatabaseTable.vala"
			_sqlite3_finalize0 (stmt);
#line 135 "../src/db/DatabaseTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 135 "../src/db/DatabaseTable.vala"
			g_clear_error (&_inner_error0_);
#line 135 "../src/db/DatabaseTable.vala"
			return;
#line 932 "DatabaseTable.c"
		}
#line 130 "../src/db/DatabaseTable.vala"
		_g_free0 (backup_path);
#line 936 "DatabaseTable.c"
	}
#line 149 "../src/db/DatabaseTable.vala"
	_tmp13_ = database_table_db;
#line 149 "../src/db/DatabaseTable.vala"
	res = _sqlite3_exec (_tmp13_, "PRAGMA synchronous=OFF", NULL, NULL, NULL);
#line 150 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_OK) {
#line 151 "../src/db/DatabaseTable.vala"
		database_table_warning ("Unable to disable synchronous mode", res);
#line 946 "DatabaseTable.c"
	}
#line 116 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 950 "DatabaseTable.c"
}

void
database_table_terminate (void)
{
#line 156 "../src/db/DatabaseTable.vala"
	_sqlite3_close0 (database_table_db);
#line 156 "../src/db/DatabaseTable.vala"
	database_table_db = NULL;
#line 960 "DatabaseTable.c"
}

void
database_table_fatal (const gchar* op,
                      gint res)
{
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
#line 160 "../src/db/DatabaseTable.vala"
	g_return_if_fail (op != NULL);
#line 161 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 161 "../src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_errmsg (_tmp0_);
#line 161 "../src/db/DatabaseTable.vala"
	g_error ("DatabaseTable.vala:161: %s: [%d] %s", op, res, _tmp1_);
#line 977 "DatabaseTable.c"
}

void
database_table_warning (const gchar* op,
                        gint res)
{
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
#line 165 "../src/db/DatabaseTable.vala"
	g_return_if_fail (op != NULL);
#line 166 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 166 "../src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_errmsg (_tmp0_);
#line 166 "../src/db/DatabaseTable.vala"
	g_warning ("DatabaseTable.vala:166: %s: [%d] %s", op, res, _tmp1_);
#line 994 "DatabaseTable.c"
}

void
database_table_set_table_name (DatabaseTable* self,
                               const gchar* table_name)
{
	gchar* _tmp0_;
#line 169 "../src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 169 "../src/db/DatabaseTable.vala"
	g_return_if_fail (table_name != NULL);
#line 170 "../src/db/DatabaseTable.vala"
	_tmp0_ = g_strdup (table_name);
#line 170 "../src/db/DatabaseTable.vala"
	_g_free0 (self->table_name);
#line 170 "../src/db/DatabaseTable.vala"
	self->table_name = _tmp0_;
#line 1012 "DatabaseTable.c"
}

void
database_table_throw_error (const gchar* method,
                            gint res,
                            GError** error)
{
	gchar* msg = NULL;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 175 "../src/db/DatabaseTable.vala"
	g_return_if_fail (method != NULL);
#line 176 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 176 "../src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_errmsg (_tmp0_);
#line 176 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("(%s) [%d] - %s", method, res, _tmp1_);
#line 176 "../src/db/DatabaseTable.vala"
	msg = _tmp2_;
#line 178 "../src/db/DatabaseTable.vala"
	switch (res) {
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_OK:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_DONE:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_ROW:
#line 1043 "DatabaseTable.c"
		{
#line 182 "../src/db/DatabaseTable.vala"
			_g_free0 (msg);
#line 182 "../src/db/DatabaseTable.vala"
			return;
#line 1049 "DatabaseTable.c"
		}
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_PERM:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_BUSY:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_READONLY:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_IOERR:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_CORRUPT:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_CANTOPEN:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_NOLFS:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_AUTH:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_FORMAT:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_NOTADB:
#line 1071 "DatabaseTable.c"
		{
			const gchar* _tmp3_;
			GError* _tmp4_;
#line 194 "../src/db/DatabaseTable.vala"
			_tmp3_ = msg;
#line 194 "../src/db/DatabaseTable.vala"
			_tmp4_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_BACKING, _tmp3_);
#line 194 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp4_;
#line 194 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 194 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 194 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 194 "../src/db/DatabaseTable.vala"
				return;
#line 1089 "DatabaseTable.c"
			} else {
#line 194 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 194 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 194 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 194 "../src/db/DatabaseTable.vala"
				return;
#line 1099 "DatabaseTable.c"
			}
		}
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_NOMEM:
#line 1104 "DatabaseTable.c"
		{
			const gchar* _tmp5_;
			GError* _tmp6_;
#line 197 "../src/db/DatabaseTable.vala"
			_tmp5_ = msg;
#line 197 "../src/db/DatabaseTable.vala"
			_tmp6_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_MEMORY, _tmp5_);
#line 197 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp6_;
#line 197 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 197 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 197 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 197 "../src/db/DatabaseTable.vala"
				return;
#line 1122 "DatabaseTable.c"
			} else {
#line 197 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 197 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 197 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 197 "../src/db/DatabaseTable.vala"
				return;
#line 1132 "DatabaseTable.c"
			}
		}
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_ABORT:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_LOCKED:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_INTERRUPT:
#line 1141 "DatabaseTable.c"
		{
			const gchar* _tmp7_;
			GError* _tmp8_;
#line 202 "../src/db/DatabaseTable.vala"
			_tmp7_ = msg;
#line 202 "../src/db/DatabaseTable.vala"
			_tmp8_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_ABORT, _tmp7_);
#line 202 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp8_;
#line 202 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 202 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 202 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 202 "../src/db/DatabaseTable.vala"
				return;
#line 1159 "DatabaseTable.c"
			} else {
#line 202 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 202 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 202 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 202 "../src/db/DatabaseTable.vala"
				return;
#line 1169 "DatabaseTable.c"
			}
		}
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_FULL:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_EMPTY:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_TOOBIG:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_CONSTRAINT:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_RANGE:
#line 1182 "DatabaseTable.c"
		{
			const gchar* _tmp9_;
			GError* _tmp10_;
#line 209 "../src/db/DatabaseTable.vala"
			_tmp9_ = msg;
#line 209 "../src/db/DatabaseTable.vala"
			_tmp10_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_LIMITS, _tmp9_);
#line 209 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp10_;
#line 209 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 209 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 209 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 209 "../src/db/DatabaseTable.vala"
				return;
#line 1200 "DatabaseTable.c"
			} else {
#line 209 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 209 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 209 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 209 "../src/db/DatabaseTable.vala"
				return;
#line 1210 "DatabaseTable.c"
			}
		}
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_SCHEMA:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_MISMATCH:
#line 1217 "DatabaseTable.c"
		{
			const gchar* _tmp11_;
			GError* _tmp12_;
#line 213 "../src/db/DatabaseTable.vala"
			_tmp11_ = msg;
#line 213 "../src/db/DatabaseTable.vala"
			_tmp12_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_TYPESPEC, _tmp11_);
#line 213 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp12_;
#line 213 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 213 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 213 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 213 "../src/db/DatabaseTable.vala"
				return;
#line 1235 "DatabaseTable.c"
			} else {
#line 213 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 213 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 213 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 213 "../src/db/DatabaseTable.vala"
				return;
#line 1245 "DatabaseTable.c"
			}
		}
		default:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_ERROR:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_INTERNAL:
#line 178 "../src/db/DatabaseTable.vala"
		case SQLITE_MISUSE:
#line 1255 "DatabaseTable.c"
		{
			const gchar* _tmp13_;
			GError* _tmp14_;
#line 219 "../src/db/DatabaseTable.vala"
			_tmp13_ = msg;
#line 219 "../src/db/DatabaseTable.vala"
			_tmp14_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_ERROR, _tmp13_);
#line 219 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp14_;
#line 219 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 219 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 219 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 219 "../src/db/DatabaseTable.vala"
				return;
#line 1273 "DatabaseTable.c"
			} else {
#line 219 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 219 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 219 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 219 "../src/db/DatabaseTable.vala"
				return;
#line 1283 "DatabaseTable.c"
			}
		}
	}
}

gboolean
database_table_exists_by_id (DatabaseTable* self,
                             gint64 id)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean result;
#line 223 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 225 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 225 "../src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 225 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("SELECT id FROM %s WHERE id=?", _tmp1_);
#line 225 "../src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 225 "../src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 225 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 225 "../src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 225 "../src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 225 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 225 "../src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 226 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 228 "../src/db/DatabaseTable.vala"
	_tmp7_ = stmt;
#line 228 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp7_, 1, id);
#line 229 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 231 "../src/db/DatabaseTable.vala"
	_tmp8_ = stmt;
#line 231 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp8_);
#line 232 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_ROW) {
#line 232 "../src/db/DatabaseTable.vala"
		_tmp9_ = res != SQLITE_DONE;
#line 1344 "DatabaseTable.c"
	} else {
#line 232 "../src/db/DatabaseTable.vala"
		_tmp9_ = FALSE;
#line 1348 "DatabaseTable.c"
	}
#line 232 "../src/db/DatabaseTable.vala"
	if (_tmp9_) {
#line 1352 "DatabaseTable.c"
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 233 "../src/db/DatabaseTable.vala"
		_tmp10_ = g_strdup_printf ("%" G_GINT64_FORMAT, id);
#line 233 "../src/db/DatabaseTable.vala"
		_tmp11_ = _tmp10_;
#line 233 "../src/db/DatabaseTable.vala"
		_tmp12_ = self->table_name;
#line 233 "../src/db/DatabaseTable.vala"
		_tmp13_ = g_strdup_printf ("exists_by_id [%s] %s", _tmp11_, _tmp12_);
#line 233 "../src/db/DatabaseTable.vala"
		_tmp14_ = _tmp13_;
#line 233 "../src/db/DatabaseTable.vala"
		database_table_fatal (_tmp14_, res);
#line 233 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp14_);
#line 233 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp11_);
#line 1374 "DatabaseTable.c"
	}
#line 235 "../src/db/DatabaseTable.vala"
	result = res == SQLITE_ROW;
#line 235 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 235 "../src/db/DatabaseTable.vala"
	return result;
#line 1382 "DatabaseTable.c"
}

gboolean
database_table_select_by_id (DatabaseTable* self,
                             gint64 id,
                             const gchar* columns,
                             sqlite3_stmt** stmt)
{
	sqlite3_stmt* _vala_stmt = NULL;
	gchar* sql = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gint res = 0;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
	sqlite3_stmt* _tmp7_;
	gboolean _tmp8_ = FALSE;
	gboolean result;
#line 238 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 238 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (columns != NULL, FALSE);
#line 239 "../src/db/DatabaseTable.vala"
	_tmp0_ = self->table_name;
#line 239 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("SELECT %s FROM %s WHERE id=?", columns, _tmp0_);
#line 239 "../src/db/DatabaseTable.vala"
	sql = _tmp1_;
#line 241 "../src/db/DatabaseTable.vala"
	_tmp2_ = database_table_db;
#line 241 "../src/db/DatabaseTable.vala"
	_tmp3_ = sql;
#line 241 "../src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp2_, _tmp3_, -1, &_tmp4_, NULL);
#line 241 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (_vala_stmt);
#line 241 "../src/db/DatabaseTable.vala"
	_vala_stmt = _tmp4_;
#line 241 "../src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 242 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 244 "../src/db/DatabaseTable.vala"
	_tmp6_ = _vala_stmt;
#line 244 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp6_, 1, id);
#line 245 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 247 "../src/db/DatabaseTable.vala"
	_tmp7_ = _vala_stmt;
#line 247 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp7_);
#line 248 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_ROW) {
#line 248 "../src/db/DatabaseTable.vala"
		_tmp8_ = res != SQLITE_DONE;
#line 1442 "DatabaseTable.c"
	} else {
#line 248 "../src/db/DatabaseTable.vala"
		_tmp8_ = FALSE;
#line 1446 "DatabaseTable.c"
	}
#line 248 "../src/db/DatabaseTable.vala"
	if (_tmp8_) {
#line 1450 "DatabaseTable.c"
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 249 "../src/db/DatabaseTable.vala"
		_tmp9_ = g_strdup_printf ("%" G_GINT64_FORMAT, id);
#line 249 "../src/db/DatabaseTable.vala"
		_tmp10_ = _tmp9_;
#line 249 "../src/db/DatabaseTable.vala"
		_tmp11_ = self->table_name;
#line 249 "../src/db/DatabaseTable.vala"
		_tmp12_ = g_strdup_printf ("select_by_id [%s] %s %s", _tmp10_, _tmp11_, columns);
#line 249 "../src/db/DatabaseTable.vala"
		_tmp13_ = _tmp12_;
#line 249 "../src/db/DatabaseTable.vala"
		database_table_fatal (_tmp13_, res);
#line 249 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp13_);
#line 249 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp10_);
#line 1472 "DatabaseTable.c"
	}
#line 251 "../src/db/DatabaseTable.vala"
	result = res == SQLITE_ROW;
#line 251 "../src/db/DatabaseTable.vala"
	_g_free0 (sql);
#line 251 "../src/db/DatabaseTable.vala"
	if (stmt) {
#line 251 "../src/db/DatabaseTable.vala"
		*stmt = _vala_stmt;
#line 1482 "DatabaseTable.c"
	} else {
#line 251 "../src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (_vala_stmt);
#line 1486 "DatabaseTable.c"
	}
#line 251 "../src/db/DatabaseTable.vala"
	return result;
#line 1490 "DatabaseTable.c"
}

static void
database_table_prepare_update_by_id (DatabaseTable* self,
                                     gint64 id,
                                     const gchar* column,
                                     sqlite3_stmt** stmt)
{
	sqlite3_stmt* _vala_stmt = NULL;
	gchar* sql = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gint res = 0;
	sqlite3* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
#line 255 "../src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 255 "../src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 256 "../src/db/DatabaseTable.vala"
	_tmp0_ = self->table_name;
#line 256 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("UPDATE %s SET %s=? WHERE id=?", _tmp0_, column);
#line 256 "../src/db/DatabaseTable.vala"
	sql = _tmp1_;
#line 258 "../src/db/DatabaseTable.vala"
	_tmp2_ = database_table_db;
#line 258 "../src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp2_, sql, -1, &_tmp3_, NULL);
#line 258 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (_vala_stmt);
#line 258 "../src/db/DatabaseTable.vala"
	_vala_stmt = _tmp3_;
#line 258 "../src/db/DatabaseTable.vala"
	res = _tmp4_;
#line 259 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 261 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_vala_stmt, 2, id);
#line 262 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 255 "../src/db/DatabaseTable.vala"
	_g_free0 (sql);
#line 255 "../src/db/DatabaseTable.vala"
	if (stmt) {
#line 255 "../src/db/DatabaseTable.vala"
		*stmt = _vala_stmt;
#line 1539 "DatabaseTable.c"
	} else {
#line 255 "../src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (_vala_stmt);
#line 1543 "DatabaseTable.c"
	}
}

static gboolean
database_table_execute_update_by_id (DatabaseTable* self,
                                     sqlite3_stmt* stmt)
{
	gint res = 0;
	gboolean result;
#line 265 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 265 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (stmt != NULL, FALSE);
#line 266 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (stmt);
#line 267 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 268 "../src/db/DatabaseTable.vala"
		database_table_fatal ("execute_update_by_id", res);
#line 270 "../src/db/DatabaseTable.vala"
		result = FALSE;
#line 270 "../src/db/DatabaseTable.vala"
		return result;
#line 1567 "DatabaseTable.c"
	}
#line 273 "../src/db/DatabaseTable.vala"
	result = TRUE;
#line 273 "../src/db/DatabaseTable.vala"
	return result;
#line 1573 "DatabaseTable.c"
}

gboolean
database_table_update_text_by_id (DatabaseTable* self,
                                  gint64 id,
                                  const gchar* column,
                                  const gchar* text)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	gchar* _tmp1_;
	GDestroyNotify _tmp2_;
	gboolean result;
#line 276 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 276 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 276 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 278 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 278 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 278 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 280 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup (text);
#line 280 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_free;
#line 280 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_text (stmt, 1, _tmp1_, -1, _tmp2_);
#line 281 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 283 "../src/db/DatabaseTable.vala"
	result = database_table_execute_update_by_id (self, stmt);
#line 283 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 283 "../src/db/DatabaseTable.vala"
	return result;
#line 1614 "DatabaseTable.c"
}

void
database_table_update_text_by_id_2 (DatabaseTable* self,
                                    gint64 id,
                                    const gchar* column,
                                    const gchar* text,
                                    GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gchar* _tmp2_;
	GDestroyNotify _tmp3_;
	sqlite3_stmt* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 286 "../src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 286 "../src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 286 "../src/db/DatabaseTable.vala"
	g_return_if_fail (text != NULL);
#line 288 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 288 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 288 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 290 "../src/db/DatabaseTable.vala"
	_tmp1_ = stmt;
#line 290 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup (text);
#line 290 "../src/db/DatabaseTable.vala"
	_tmp3_ = g_free;
#line 290 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_text (_tmp1_, 1, _tmp2_, -1, _tmp3_);
#line 291 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 293 "../src/db/DatabaseTable.vala"
	_tmp4_ = stmt;
#line 293 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp4_);
#line 294 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1660 "DatabaseTable.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 295 "../src/db/DatabaseTable.vala"
		_tmp5_ = self->table_name;
#line 295 "../src/db/DatabaseTable.vala"
		_tmp6_ = g_strdup_printf ("DatabaseTable.update_text_by_id_2 %s.%s", _tmp5_, column);
#line 295 "../src/db/DatabaseTable.vala"
		_tmp7_ = _tmp6_;
#line 295 "../src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp7_, res, &_inner_error0_);
#line 295 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp7_);
#line 295 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 295 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 295 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 295 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 295 "../src/db/DatabaseTable.vala"
				return;
#line 1684 "DatabaseTable.c"
			} else {
#line 295 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 295 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 295 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 295 "../src/db/DatabaseTable.vala"
				return;
#line 1694 "DatabaseTable.c"
			}
		}
	}
#line 286 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1700 "DatabaseTable.c"
}

gboolean
database_table_update_int_by_id (DatabaseTable* self,
                                 gint64 id,
                                 const gchar* column,
                                 gint value)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	gboolean result;
#line 298 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 298 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 300 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 300 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 300 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 302 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int (stmt, 1, value);
#line 303 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 305 "../src/db/DatabaseTable.vala"
	result = database_table_execute_update_by_id (self, stmt);
#line 305 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 305 "../src/db/DatabaseTable.vala"
	return result;
#line 1733 "DatabaseTable.c"
}

void
database_table_update_int_by_id_2 (DatabaseTable* self,
                                   gint64 id,
                                   const gchar* column,
                                   gint value,
                                   GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 308 "../src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 308 "../src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 310 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 310 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 310 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 312 "../src/db/DatabaseTable.vala"
	_tmp1_ = stmt;
#line 312 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int (_tmp1_, 1, value);
#line 313 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 315 "../src/db/DatabaseTable.vala"
	_tmp2_ = stmt;
#line 315 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp2_);
#line 316 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1771 "DatabaseTable.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 317 "../src/db/DatabaseTable.vala"
		_tmp3_ = self->table_name;
#line 317 "../src/db/DatabaseTable.vala"
		_tmp4_ = g_strdup_printf ("DatabaseTable.update_int_by_id_2 %s.%s", _tmp3_, column);
#line 317 "../src/db/DatabaseTable.vala"
		_tmp5_ = _tmp4_;
#line 317 "../src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp5_, res, &_inner_error0_);
#line 317 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp5_);
#line 317 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 317 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 317 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 317 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 317 "../src/db/DatabaseTable.vala"
				return;
#line 1795 "DatabaseTable.c"
			} else {
#line 317 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 317 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 317 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 317 "../src/db/DatabaseTable.vala"
				return;
#line 1805 "DatabaseTable.c"
			}
		}
	}
#line 308 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1811 "DatabaseTable.c"
}

gboolean
database_table_update_int64_by_id (DatabaseTable* self,
                                   gint64 id,
                                   const gchar* column,
                                   gint64 value)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	gboolean result;
#line 320 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 320 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 322 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 322 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 322 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 324 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (stmt, 1, value);
#line 325 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 327 "../src/db/DatabaseTable.vala"
	result = database_table_execute_update_by_id (self, stmt);
#line 327 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 327 "../src/db/DatabaseTable.vala"
	return result;
#line 1844 "DatabaseTable.c"
}

void
database_table_update_int64_by_id_2 (DatabaseTable* self,
                                     gint64 id,
                                     const gchar* column,
                                     gint64 value,
                                     GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 330 "../src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 330 "../src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 332 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 332 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 332 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 334 "../src/db/DatabaseTable.vala"
	_tmp1_ = stmt;
#line 334 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp1_, 1, value);
#line 335 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 337 "../src/db/DatabaseTable.vala"
	_tmp2_ = stmt;
#line 337 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp2_);
#line 338 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1882 "DatabaseTable.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 339 "../src/db/DatabaseTable.vala"
		_tmp3_ = self->table_name;
#line 339 "../src/db/DatabaseTable.vala"
		_tmp4_ = g_strdup_printf ("DatabaseTable.update_int64_by_id_2 %s.%s", _tmp3_, column);
#line 339 "../src/db/DatabaseTable.vala"
		_tmp5_ = _tmp4_;
#line 339 "../src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp5_, res, &_inner_error0_);
#line 339 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp5_);
#line 339 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 339 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 339 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 339 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 339 "../src/db/DatabaseTable.vala"
				return;
#line 1906 "DatabaseTable.c"
			} else {
#line 339 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 339 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 339 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 339 "../src/db/DatabaseTable.vala"
				return;
#line 1916 "DatabaseTable.c"
			}
		}
	}
#line 330 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1922 "DatabaseTable.c"
}

void
database_table_update_double_by_id_2 (DatabaseTable* self,
                                      gint64 id,
                                      const gchar* column,
                                      gdouble value,
                                      GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 342 "../src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 342 "../src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 344 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 344 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 344 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 346 "../src/db/DatabaseTable.vala"
	_tmp1_ = stmt;
#line 346 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_double (_tmp1_, 1, value);
#line 347 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 349 "../src/db/DatabaseTable.vala"
	_tmp2_ = stmt;
#line 349 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp2_);
#line 350 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1960 "DatabaseTable.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 351 "../src/db/DatabaseTable.vala"
		_tmp3_ = self->table_name;
#line 351 "../src/db/DatabaseTable.vala"
		_tmp4_ = g_strdup_printf ("DatabaseTable.update_double_by_id_2 %s.%s", _tmp3_, column);
#line 351 "../src/db/DatabaseTable.vala"
		_tmp5_ = _tmp4_;
#line 351 "../src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp5_, res, &_inner_error0_);
#line 351 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp5_);
#line 351 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 351 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 351 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 351 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 351 "../src/db/DatabaseTable.vala"
				return;
#line 1984 "DatabaseTable.c"
			} else {
#line 351 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 351 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 351 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 351 "../src/db/DatabaseTable.vala"
				return;
#line 1994 "DatabaseTable.c"
			}
		}
	}
#line 342 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2000 "DatabaseTable.c"
}

void
database_table_delete_by_id (DatabaseTable* self,
                             gint64 id,
                             GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 354 "../src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 356 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 356 "../src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 356 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("DELETE FROM %s WHERE id=?", _tmp1_);
#line 356 "../src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 356 "../src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 356 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 356 "../src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 356 "../src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 356 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 356 "../src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 357 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 359 "../src/db/DatabaseTable.vala"
	_tmp7_ = stmt;
#line 359 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp7_, 1, id);
#line 360 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 362 "../src/db/DatabaseTable.vala"
	_tmp8_ = stmt;
#line 362 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp8_);
#line 363 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 2056 "DatabaseTable.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 364 "../src/db/DatabaseTable.vala"
		_tmp9_ = self->table_name;
#line 364 "../src/db/DatabaseTable.vala"
		_tmp10_ = g_strdup_printf ("%s.remove", _tmp9_);
#line 364 "../src/db/DatabaseTable.vala"
		_tmp11_ = _tmp10_;
#line 364 "../src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp11_, res, &_inner_error0_);
#line 364 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp11_);
#line 364 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 364 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 364 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 364 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 364 "../src/db/DatabaseTable.vala"
				return;
#line 2080 "DatabaseTable.c"
			} else {
#line 364 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 364 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 364 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 364 "../src/db/DatabaseTable.vala"
				return;
#line 2090 "DatabaseTable.c"
			}
		}
	}
#line 354 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2096 "DatabaseTable.c"
}

gboolean
database_table_has_column (const gchar* table_name,
                           const gchar* column_name)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
	gboolean result;
#line 367 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 367 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 369 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 369 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("PRAGMA table_info(%s)", table_name);
#line 369 "../src/db/DatabaseTable.vala"
	_tmp2_ = _tmp1_;
#line 369 "../src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, _tmp2_, -1, &_tmp3_, NULL);
#line 369 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 369 "../src/db/DatabaseTable.vala"
	stmt = _tmp3_;
#line 369 "../src/db/DatabaseTable.vala"
	_tmp5_ = _tmp4_;
#line 369 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp2_);
#line 369 "../src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 370 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 2136 "DatabaseTable.c"
	{
		gboolean _tmp6_ = FALSE;
#line 372 "../src/db/DatabaseTable.vala"
		_tmp6_ = TRUE;
#line 372 "../src/db/DatabaseTable.vala"
		while (TRUE) {
#line 2143 "DatabaseTable.c"
			sqlite3_stmt* _tmp7_;
#line 372 "../src/db/DatabaseTable.vala"
			if (!_tmp6_) {
#line 2147 "DatabaseTable.c"
			}
#line 372 "../src/db/DatabaseTable.vala"
			_tmp6_ = FALSE;
#line 373 "../src/db/DatabaseTable.vala"
			_tmp7_ = stmt;
#line 373 "../src/db/DatabaseTable.vala"
			res = sqlite3_step (_tmp7_);
#line 374 "../src/db/DatabaseTable.vala"
			if (res == SQLITE_DONE) {
#line 375 "../src/db/DatabaseTable.vala"
				break;
#line 2159 "DatabaseTable.c"
			} else {
#line 376 "../src/db/DatabaseTable.vala"
				if (res != SQLITE_ROW) {
#line 2163 "DatabaseTable.c"
					gchar* _tmp8_;
					gchar* _tmp9_;
#line 377 "../src/db/DatabaseTable.vala"
					_tmp8_ = g_strdup_printf ("has_column %s", table_name);
#line 377 "../src/db/DatabaseTable.vala"
					_tmp9_ = _tmp8_;
#line 377 "../src/db/DatabaseTable.vala"
					database_table_fatal (_tmp9_, res);
#line 377 "../src/db/DatabaseTable.vala"
					_g_free0 (_tmp9_);
#line 379 "../src/db/DatabaseTable.vala"
					break;
#line 2176 "DatabaseTable.c"
				} else {
					gchar* column = NULL;
					sqlite3_stmt* _tmp10_;
					const gchar* _tmp11_;
					gchar* _tmp12_;
					gboolean _tmp13_ = FALSE;
					const gchar* _tmp14_;
#line 381 "../src/db/DatabaseTable.vala"
					_tmp10_ = stmt;
#line 381 "../src/db/DatabaseTable.vala"
					_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 1);
#line 381 "../src/db/DatabaseTable.vala"
					_tmp12_ = g_strdup (_tmp11_);
#line 381 "../src/db/DatabaseTable.vala"
					column = _tmp12_;
#line 382 "../src/db/DatabaseTable.vala"
					_tmp14_ = column;
#line 382 "../src/db/DatabaseTable.vala"
					if (_tmp14_ != NULL) {
#line 2196 "DatabaseTable.c"
						const gchar* _tmp15_;
#line 382 "../src/db/DatabaseTable.vala"
						_tmp15_ = column;
#line 382 "../src/db/DatabaseTable.vala"
						_tmp13_ = g_strcmp0 (_tmp15_, column_name) == 0;
#line 2202 "DatabaseTable.c"
					} else {
#line 382 "../src/db/DatabaseTable.vala"
						_tmp13_ = FALSE;
#line 2206 "DatabaseTable.c"
					}
#line 382 "../src/db/DatabaseTable.vala"
					if (_tmp13_) {
#line 383 "../src/db/DatabaseTable.vala"
						result = TRUE;
#line 383 "../src/db/DatabaseTable.vala"
						_g_free0 (column);
#line 383 "../src/db/DatabaseTable.vala"
						_sqlite3_finalize0 (stmt);
#line 383 "../src/db/DatabaseTable.vala"
						return result;
#line 2218 "DatabaseTable.c"
					}
#line 376 "../src/db/DatabaseTable.vala"
					_g_free0 (column);
#line 2222 "DatabaseTable.c"
				}
			}
		}
	}
#line 387 "../src/db/DatabaseTable.vala"
	result = FALSE;
#line 387 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 387 "../src/db/DatabaseTable.vala"
	return result;
#line 2233 "DatabaseTable.c"
}

gboolean
database_table_has_table (const gchar* table_name)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
	gboolean result;
#line 390 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 392 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 392 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("PRAGMA table_info(%s)", table_name);
#line 392 "../src/db/DatabaseTable.vala"
	_tmp2_ = _tmp1_;
#line 392 "../src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, _tmp2_, -1, &_tmp3_, NULL);
#line 392 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 392 "../src/db/DatabaseTable.vala"
	stmt = _tmp3_;
#line 392 "../src/db/DatabaseTable.vala"
	_tmp5_ = _tmp4_;
#line 392 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp2_);
#line 392 "../src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 393 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 395 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (stmt);
#line 397 "../src/db/DatabaseTable.vala"
	result = res != SQLITE_DONE;
#line 397 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 397 "../src/db/DatabaseTable.vala"
	return result;
#line 2278 "DatabaseTable.c"
}

gboolean
database_table_add_column (const gchar* table_name,
                           const gchar* column_name,
                           const gchar* column_constraints)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
	gboolean result;
#line 400 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 400 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 400 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_constraints != NULL, FALSE);
#line 402 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 402 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("ALTER TABLE %s ADD COLUMN %s %s", table_name, column_name, column_constraints);
#line 402 "../src/db/DatabaseTable.vala"
	_tmp2_ = _tmp1_;
#line 402 "../src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, _tmp2_, -1, &_tmp3_, NULL);
#line 402 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 402 "../src/db/DatabaseTable.vala"
	stmt = _tmp3_;
#line 402 "../src/db/DatabaseTable.vala"
	_tmp5_ = _tmp4_;
#line 402 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp2_);
#line 402 "../src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 404 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 406 "../src/db/DatabaseTable.vala"
	_tmp6_ = stmt;
#line 406 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp6_);
#line 407 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 2328 "DatabaseTable.c"
		sqlite3* _tmp7_;
		const gchar* _tmp8_;
#line 408 "../src/db/DatabaseTable.vala"
		_tmp7_ = database_table_db;
#line 408 "../src/db/DatabaseTable.vala"
		_tmp8_ = sqlite3_errmsg (_tmp7_);
#line 408 "../src/db/DatabaseTable.vala"
		g_critical ("DatabaseTable.vala:408: Unable to add column %s %s %s: (%d) %s", table_name, column_name, column_constraints, res, _tmp8_);
#line 411 "../src/db/DatabaseTable.vala"
		result = FALSE;
#line 411 "../src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (stmt);
#line 411 "../src/db/DatabaseTable.vala"
		return result;
#line 2343 "DatabaseTable.c"
	}
#line 414 "../src/db/DatabaseTable.vala"
	result = TRUE;
#line 414 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 414 "../src/db/DatabaseTable.vala"
	return result;
#line 2351 "DatabaseTable.c"
}

gboolean
database_table_ensure_column (const gchar* table_name,
                              const gchar* column_name,
                              const gchar* column_constraints,
                              const gchar* upgrade_msg)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 420 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 420 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 420 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_constraints != NULL, FALSE);
#line 420 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (upgrade_msg != NULL, FALSE);
#line 422 "../src/db/DatabaseTable.vala"
	if (!database_table_has_table (table_name)) {
#line 422 "../src/db/DatabaseTable.vala"
		_tmp0_ = TRUE;
#line 2374 "DatabaseTable.c"
	} else {
#line 422 "../src/db/DatabaseTable.vala"
		_tmp0_ = database_table_has_column (table_name, column_name);
#line 2378 "DatabaseTable.c"
	}
#line 422 "../src/db/DatabaseTable.vala"
	if (_tmp0_) {
#line 423 "../src/db/DatabaseTable.vala"
		result = TRUE;
#line 423 "../src/db/DatabaseTable.vala"
		return result;
#line 2386 "DatabaseTable.c"
	}
#line 425 "../src/db/DatabaseTable.vala"
	g_message ("DatabaseTable.vala:425: %s", upgrade_msg);
#line 427 "../src/db/DatabaseTable.vala"
	result = database_table_add_column (table_name, column_name, column_constraints);
#line 427 "../src/db/DatabaseTable.vala"
	return result;
#line 2394 "DatabaseTable.c"
}

gint
database_table_get_row_count (DatabaseTable* self)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp11_;
	gint result;
#line 430 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), 0);
#line 432 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 432 "../src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 432 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("SELECT COUNT(id) AS RowCount FROM %s", _tmp1_);
#line 432 "../src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 432 "../src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 432 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 432 "../src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 432 "../src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 432 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 432 "../src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 433 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 435 "../src/db/DatabaseTable.vala"
	_tmp7_ = stmt;
#line 435 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp7_);
#line 436 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_ROW) {
#line 2442 "DatabaseTable.c"
		const gchar* _tmp8_;
		sqlite3* _tmp9_;
		const gchar* _tmp10_;
#line 437 "../src/db/DatabaseTable.vala"
		_tmp8_ = self->table_name;
#line 437 "../src/db/DatabaseTable.vala"
		_tmp9_ = database_table_db;
#line 437 "../src/db/DatabaseTable.vala"
		_tmp10_ = sqlite3_errmsg (_tmp9_);
#line 437 "../src/db/DatabaseTable.vala"
		g_critical ("DatabaseTable.vala:437: Unable to retrieve row count on %s: (%d) %s", _tmp8_, res, _tmp10_);
#line 439 "../src/db/DatabaseTable.vala"
		result = 0;
#line 439 "../src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (stmt);
#line 439 "../src/db/DatabaseTable.vala"
		return result;
#line 2460 "DatabaseTable.c"
	}
#line 442 "../src/db/DatabaseTable.vala"
	_tmp11_ = stmt;
#line 442 "../src/db/DatabaseTable.vala"
	result = sqlite3_column_int (_tmp11_, 0);
#line 442 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 442 "../src/db/DatabaseTable.vala"
	return result;
#line 2470 "DatabaseTable.c"
}

void
database_table_begin_transaction (void)
{
	gint _tmp0_;
	gint res = 0;
	sqlite3* _tmp1_;
#line 447 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_in_transaction;
#line 447 "../src/db/DatabaseTable.vala"
	database_table_in_transaction = _tmp0_ + 1;
#line 447 "../src/db/DatabaseTable.vala"
	if (_tmp0_ != 0) {
#line 448 "../src/db/DatabaseTable.vala"
		return;
#line 2487 "DatabaseTable.c"
	}
#line 450 "../src/db/DatabaseTable.vala"
	_tmp1_ = database_table_db;
#line 450 "../src/db/DatabaseTable.vala"
	res = _sqlite3_exec (_tmp1_, "BEGIN TRANSACTION", NULL, NULL, NULL);
#line 451 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 2495 "DatabaseTable.c"
}

void
database_table_commit_transaction (GError** error)
{
	gint _tmp0_;
	gint res = 0;
	sqlite3* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 456 "../src/db/DatabaseTable.vala"
	_vala_assert (database_table_in_transaction > 0, "in_transaction > 0");
#line 457 "../src/db/DatabaseTable.vala"
	database_table_in_transaction = database_table_in_transaction - 1;
#line 457 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_in_transaction;
#line 457 "../src/db/DatabaseTable.vala"
	if (_tmp0_ != 0) {
#line 458 "../src/db/DatabaseTable.vala"
		return;
#line 2515 "DatabaseTable.c"
	}
#line 460 "../src/db/DatabaseTable.vala"
	_tmp1_ = database_table_db;
#line 460 "../src/db/DatabaseTable.vala"
	res = _sqlite3_exec (_tmp1_, "COMMIT TRANSACTION", NULL, NULL, NULL);
#line 461 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 462 "../src/db/DatabaseTable.vala"
		database_table_throw_error ("commit_transaction", res, &_inner_error0_);
#line 462 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 462 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 462 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 462 "../src/db/DatabaseTable.vala"
				return;
#line 2533 "DatabaseTable.c"
			} else {
#line 462 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 462 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 462 "../src/db/DatabaseTable.vala"
				return;
#line 2541 "DatabaseTable.c"
			}
		}
	}
}

DatabaseTable*
database_table_construct (GType object_type)
{
	DatabaseTable* self = NULL;
#line 16 "../src/db/DatabaseTable.vala"
	self = (DatabaseTable*) g_type_create_instance (object_type);
#line 16 "../src/db/DatabaseTable.vala"
	return self;
#line 2555 "DatabaseTable.c"
}

static void
value_database_table_init (GValue* value)
{
#line 16 "../src/db/DatabaseTable.vala"
	value->data[0].v_pointer = NULL;
#line 2563 "DatabaseTable.c"
}

static void
value_database_table_free_value (GValue* value)
{
#line 16 "../src/db/DatabaseTable.vala"
	if (value->data[0].v_pointer) {
#line 16 "../src/db/DatabaseTable.vala"
		database_table_unref (value->data[0].v_pointer);
#line 2573 "DatabaseTable.c"
	}
}

static void
value_database_table_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 16 "../src/db/DatabaseTable.vala"
	if (src_value->data[0].v_pointer) {
#line 16 "../src/db/DatabaseTable.vala"
		dest_value->data[0].v_pointer = database_table_ref (src_value->data[0].v_pointer);
#line 2585 "DatabaseTable.c"
	} else {
#line 16 "../src/db/DatabaseTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2589 "DatabaseTable.c"
	}
}

static gpointer
value_database_table_peek_pointer (const GValue* value)
{
#line 16 "../src/db/DatabaseTable.vala"
	return value->data[0].v_pointer;
#line 2598 "DatabaseTable.c"
}

static gchar*
value_database_table_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 16 "../src/db/DatabaseTable.vala"
	if (collect_values[0].v_pointer) {
#line 2609 "DatabaseTable.c"
		DatabaseTable * object;
		object = collect_values[0].v_pointer;
#line 16 "../src/db/DatabaseTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 16 "../src/db/DatabaseTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2616 "DatabaseTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 16 "../src/db/DatabaseTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2620 "DatabaseTable.c"
		}
#line 16 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = database_table_ref (object);
#line 2624 "DatabaseTable.c"
	} else {
#line 16 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2628 "DatabaseTable.c"
	}
#line 16 "../src/db/DatabaseTable.vala"
	return NULL;
#line 2632 "DatabaseTable.c"
}

static gchar*
value_database_table_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	DatabaseTable ** object_p;
	object_p = collect_values[0].v_pointer;
#line 16 "../src/db/DatabaseTable.vala"
	if (!object_p) {
#line 16 "../src/db/DatabaseTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2647 "DatabaseTable.c"
	}
#line 16 "../src/db/DatabaseTable.vala"
	if (!value->data[0].v_pointer) {
#line 16 "../src/db/DatabaseTable.vala"
		*object_p = NULL;
#line 2653 "DatabaseTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 16 "../src/db/DatabaseTable.vala"
		*object_p = value->data[0].v_pointer;
#line 2657 "DatabaseTable.c"
	} else {
#line 16 "../src/db/DatabaseTable.vala"
		*object_p = database_table_ref (value->data[0].v_pointer);
#line 2661 "DatabaseTable.c"
	}
#line 16 "../src/db/DatabaseTable.vala"
	return NULL;
#line 2665 "DatabaseTable.c"
}

GParamSpec*
param_spec_database_table (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecDatabaseTable* spec;
#line 16 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DATABASE_TABLE), NULL);
#line 16 "../src/db/DatabaseTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 16 "../src/db/DatabaseTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 16 "../src/db/DatabaseTable.vala"
	return G_PARAM_SPEC (spec);
#line 2684 "DatabaseTable.c"
}

gpointer
value_get_database_table (const GValue* value)
{
#line 16 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE), NULL);
#line 16 "../src/db/DatabaseTable.vala"
	return value->data[0].v_pointer;
#line 2694 "DatabaseTable.c"
}

void
value_set_database_table (GValue* value,
                          gpointer v_object)
{
	DatabaseTable * old;
#line 16 "../src/db/DatabaseTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE));
#line 16 "../src/db/DatabaseTable.vala"
	old = value->data[0].v_pointer;
#line 16 "../src/db/DatabaseTable.vala"
	if (v_object) {
#line 16 "../src/db/DatabaseTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATABASE_TABLE));
#line 16 "../src/db/DatabaseTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 16 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = v_object;
#line 16 "../src/db/DatabaseTable.vala"
		database_table_ref (value->data[0].v_pointer);
#line 2716 "DatabaseTable.c"
	} else {
#line 16 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2720 "DatabaseTable.c"
	}
#line 16 "../src/db/DatabaseTable.vala"
	if (old) {
#line 16 "../src/db/DatabaseTable.vala"
		database_table_unref (old);
#line 2726 "DatabaseTable.c"
	}
}

void
value_take_database_table (GValue* value,
                           gpointer v_object)
{
	DatabaseTable * old;
#line 16 "../src/db/DatabaseTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE));
#line 16 "../src/db/DatabaseTable.vala"
	old = value->data[0].v_pointer;
#line 16 "../src/db/DatabaseTable.vala"
	if (v_object) {
#line 16 "../src/db/DatabaseTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATABASE_TABLE));
#line 16 "../src/db/DatabaseTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 16 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = v_object;
#line 2747 "DatabaseTable.c"
	} else {
#line 16 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2751 "DatabaseTable.c"
	}
#line 16 "../src/db/DatabaseTable.vala"
	if (old) {
#line 16 "../src/db/DatabaseTable.vala"
		database_table_unref (old);
#line 2757 "DatabaseTable.c"
	}
}

static void
database_table_class_init (DatabaseTableClass * klass,
                           gpointer klass_data)
{
#line 16 "../src/db/DatabaseTable.vala"
	database_table_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/db/DatabaseTable.vala"
	((DatabaseTableClass *) klass)->finalize = database_table_finalize;
#line 2769 "DatabaseTable.c"
}

static void
database_table_instance_init (DatabaseTable * self,
                              gpointer klass)
{
#line 30 "../src/db/DatabaseTable.vala"
	self->table_name = NULL;
#line 16 "../src/db/DatabaseTable.vala"
	self->ref_count = 1;
#line 2780 "DatabaseTable.c"
}

static void
database_table_finalize (DatabaseTable * obj)
{
	DatabaseTable * self;
#line 16 "../src/db/DatabaseTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DATABASE_TABLE, DatabaseTable);
#line 16 "../src/db/DatabaseTable.vala"
	g_signal_handlers_destroy (self);
#line 30 "../src/db/DatabaseTable.vala"
	_g_free0 (self->table_name);
#line 2793 "DatabaseTable.c"
}

static GType
database_table_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_database_table_init, value_database_table_free_value, value_database_table_copy_value, value_database_table_peek_pointer, "p", value_database_table_collect_value, "p", value_database_table_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (DatabaseTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) database_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DatabaseTable), 0, (GInstanceInitFunc) database_table_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType database_table_type_id;
	database_table_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DatabaseTable", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return database_table_type_id;
}

GType
database_table_get_type (void)
{
	static volatile gsize database_table_type_id__once = 0;
	if (g_once_init_enter (&database_table_type_id__once)) {
		GType database_table_type_id;
		database_table_type_id = database_table_get_type_once ();
		g_once_init_leave (&database_table_type_id__once, database_table_type_id);
	}
	return database_table_type_id__once;
}

gpointer
database_table_ref (gpointer instance)
{
	DatabaseTable * self;
	self = instance;
#line 16 "../src/db/DatabaseTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 16 "../src/db/DatabaseTable.vala"
	return instance;
#line 2828 "DatabaseTable.c"
}

void
database_table_unref (gpointer instance)
{
	DatabaseTable * self;
	self = instance;
#line 16 "../src/db/DatabaseTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 16 "../src/db/DatabaseTable.vala"
		DATABASE_TABLE_GET_CLASS (self)->finalize (self);
#line 16 "../src/db/DatabaseTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2842 "DatabaseTable.c"
	}
}

