/* Db.c generated by valac 0.56.18, the Vala compiler
 * generated from Db.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <config.h>

#define DB_IN_MEMORY_NAME ":memory:"
#define DATABASE_TABLE_SCHEMA_VERSION 24
#define RESOURCES_APP_VERSION _VERSION
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	DB_VERIFY_RESULT_OK,
	DB_VERIFY_RESULT_FUTURE_VERSION,
	DB_VERIFY_RESULT_UPGRADE_ERROR,
	DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE
} DbVerifyResult;

#define DB_TYPE_VERIFY_RESULT (db_verify_result_get_type ())

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_VERSION_TABLE (version_table_get_type ())
#define VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VERSION_TABLE, VersionTable))
#define VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VERSION_TABLE, VersionTableClass))
#define IS_VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VERSION_TABLE))
#define IS_VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VERSION_TABLE))
#define VERSION_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VERSION_TABLE, VersionTableClass))

typedef struct _VersionTable VersionTable;
typedef struct _VersionTableClass VersionTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define TYPE_DATABASE_ERROR (database_error_get_type ())

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;
#define _application_unref0(var) ((var == NULL) ? NULL : (var = (application_unref (var), NULL)))

#define TYPE_FACE_TABLE (face_table_get_type ())
#define FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_TABLE, FaceTable))
#define FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_TABLE, FaceTableClass))
#define IS_FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_TABLE))
#define IS_FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_TABLE))
#define FACE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_TABLE, FaceTableClass))

typedef struct _FaceTable FaceTable;
typedef struct _FaceTableClass FaceTableClass;

#define TYPE_FACE_LOCATION_TABLE (face_location_table_get_type ())
#define FACE_LOCATION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_LOCATION_TABLE, FaceLocationTable))
#define FACE_LOCATION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_LOCATION_TABLE, FaceLocationTableClass))
#define IS_FACE_LOCATION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_LOCATION_TABLE))
#define IS_FACE_LOCATION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_LOCATION_TABLE))
#define FACE_LOCATION_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_LOCATION_TABLE, FaceLocationTableClass))

typedef struct _FaceLocationTable FaceLocationTable;
typedef struct _FaceLocationTableClass FaceLocationTableClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

VALA_EXTERN gchar* db_filename;
gchar* db_filename = NULL;

VALA_EXTERN void db_preconfigure (GFile* db_file);
VALA_EXTERN void db_init (GError** error);
VALA_EXTERN void database_table_init (const gchar* filename);
VALA_EXTERN void db_terminate (void);
VALA_EXTERN void database_table_terminate (void);
VALA_EXTERN GType db_verify_result_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DbVerifyResult db_verify_database (gchar** app_version,
                                   gint* schema_version);
VALA_EXTERN gpointer database_table_ref (gpointer instance);
VALA_EXTERN void database_table_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_database_table (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_database_table (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_database_table (const GValue* value);
VALA_EXTERN GType database_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
VALA_EXTERN GType version_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VersionTable, database_table_unref)
VALA_EXTERN VersionTable* version_table_get_instance (void);
VALA_EXTERN gint version_table_get_version (VersionTable* self,
                                gchar** app_version);
VALA_EXTERN void version_table_set_version (VersionTable* self,
                                gint version,
                                const gchar* app_version,
                                const gchar* user_data);
VALA_EXTERN DbVerifyResult db_upgrade_database (gint input_version);
VALA_EXTERN GQuark database_error_quark (void);
VALA_EXTERN GType database_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void photo_table_clean_comments (GError** error);
VALA_EXTERN void video_table_clean_comments (GError** error);
VALA_EXTERN gboolean database_table_has_column (const gchar* table_name,
                                    const gchar* column_name);
VALA_EXTERN gboolean database_table_add_column (const gchar* table_name,
                                    const gchar* column_name,
                                    const gchar* column_constraints);
VALA_EXTERN gboolean database_table_has_table (const gchar* table_name);
VALA_EXTERN gboolean database_table_ensure_column (const gchar* table_name,
                                       const gchar* column_name,
                                       const gchar* column_constraints,
                                       const gchar* upgrade_msg);
VALA_EXTERN void tag_table_upgrade_for_htags (void);
VALA_EXTERN void gsettings_configuration_engine_run_gsettings_migrator (void);
VALA_EXTERN gpointer application_ref (gpointer instance);
VALA_EXTERN void application_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_application (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_application (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_application (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_application (const GValue* value);
VALA_EXTERN GType application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Application, application_unref)
VALA_EXTERN Application* application_get_instance (void);
VALA_EXTERN void application_set_raw_thumbs_fix_required (Application* self,
                                              gboolean should_fixup);
VALA_EXTERN GType face_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FaceTable, database_table_unref)
VALA_EXTERN FaceTable* face_table_get_instance (void);
VALA_EXTERN GType face_location_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FaceLocationTable, database_table_unref)
VALA_EXTERN FaceLocationTable* face_location_table_get_instance (void);
VALA_EXTERN void gsettings_configuration_engine_run_gsettings_migrator_v2 (void);
VALA_EXTERN void photo_table_upgrade_for_unset_timestamp (GError** error);
VALA_EXTERN void video_table_upgrade_for_unset_timestamp (GError** error);
VALA_EXTERN void version_table_update_version (VersionTable* self,
                                   gint version,
                                   const gchar* app_version);

void
db_preconfigure (GFile* db_file)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp3_;
#line 14 "../src/db/Db.vala"
	g_return_if_fail ((db_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (db_file, g_file_get_type ()));
#line 15 "../src/db/Db.vala"
	if (db_file != NULL) {
#line 208 "Db.c"
		gchar* _tmp1_;
#line 15 "../src/db/Db.vala"
		_tmp1_ = g_file_get_path (db_file);
#line 15 "../src/db/Db.vala"
		_g_free0 (_tmp0_);
#line 15 "../src/db/Db.vala"
		_tmp0_ = _tmp1_;
#line 216 "Db.c"
	} else {
		gchar* _tmp2_;
#line 15 "../src/db/Db.vala"
		_tmp2_ = g_strdup (DB_IN_MEMORY_NAME);
#line 15 "../src/db/Db.vala"
		_g_free0 (_tmp0_);
#line 15 "../src/db/Db.vala"
		_tmp0_ = _tmp2_;
#line 225 "Db.c"
	}
#line 15 "../src/db/Db.vala"
	_tmp3_ = g_strdup (_tmp0_);
#line 15 "../src/db/Db.vala"
	_g_free0 (db_filename);
#line 15 "../src/db/Db.vala"
	db_filename = _tmp3_;
#line 14 "../src/db/Db.vala"
	_g_free0 (_tmp0_);
#line 235 "Db.c"
}

void
db_init (GError** error)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 19 "../src/db/Db.vala"
	_tmp0_ = db_filename;
#line 19 "../src/db/Db.vala"
	_vala_assert (_tmp0_ != NULL, "filename != null");
#line 21 "../src/db/Db.vala"
	_tmp1_ = db_filename;
#line 21 "../src/db/Db.vala"
	database_table_init (_tmp1_);
#line 251 "Db.c"
}

void
db_terminate (void)
{
#line 25 "../src/db/Db.vala"
	database_table_terminate ();
#line 259 "Db.c"
}

static GType
db_verify_result_get_type_once (void)
{
	static const GEnumValue values[] = {{DB_VERIFY_RESULT_OK, "DB_VERIFY_RESULT_OK", "ok"}, {DB_VERIFY_RESULT_FUTURE_VERSION, "DB_VERIFY_RESULT_FUTURE_VERSION", "future-version"}, {DB_VERIFY_RESULT_UPGRADE_ERROR, "DB_VERIFY_RESULT_UPGRADE_ERROR", "upgrade-error"}, {DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE, "DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE", "no-upgrade-available"}, {0, NULL, NULL}};
	GType db_verify_result_type_id;
	db_verify_result_type_id = g_enum_register_static ("DbVerifyResult", values);
	return db_verify_result_type_id;
}

GType
db_verify_result_get_type (void)
{
	static volatile gsize db_verify_result_type_id__once = 0;
	if (g_once_init_enter (&db_verify_result_type_id__once)) {
		GType db_verify_result_type_id;
		db_verify_result_type_id = db_verify_result_get_type_once ();
		g_once_init_leave (&db_verify_result_type_id__once, db_verify_result_type_id);
	}
	return db_verify_result_type_id__once;
}

DbVerifyResult
db_verify_database (gchar** app_version,
                    gint* schema_version)
{
	gchar* _vala_app_version = NULL;
	gint _vala_schema_version = 0;
	VersionTable* version_table = NULL;
	VersionTable* _tmp0_;
	VersionTable* _tmp1_;
	gchar* _tmp2_ = NULL;
	gint _tmp3_;
	GError* _inner_error0_ = NULL;
	DbVerifyResult result;
#line 36 "../src/db/Db.vala"
	_tmp0_ = version_table_get_instance ();
#line 36 "../src/db/Db.vala"
	version_table = _tmp0_;
#line 37 "../src/db/Db.vala"
	_tmp1_ = version_table;
#line 37 "../src/db/Db.vala"
	_tmp3_ = version_table_get_version (_tmp1_, &_tmp2_);
#line 37 "../src/db/Db.vala"
	_g_free0 (_vala_app_version);
#line 37 "../src/db/Db.vala"
	_vala_app_version = _tmp2_;
#line 37 "../src/db/Db.vala"
	_vala_schema_version = _tmp3_;
#line 39 "../src/db/Db.vala"
	if (_vala_schema_version >= 0) {
#line 312 "Db.c"
		const gchar* _tmp4_;
#line 40 "../src/db/Db.vala"
		_tmp4_ = _vala_app_version;
#line 40 "../src/db/Db.vala"
		g_debug ("Db.vala:40: Database schema version %d created by app version %s", _vala_schema_version, _tmp4_);
#line 318 "Db.c"
	}
#line 42 "../src/db/Db.vala"
	if (_vala_schema_version == -1) {
#line 322 "Db.c"
		VersionTable* _tmp5_;
		gchar* _tmp6_;
#line 44 "../src/db/Db.vala"
		g_debug ("Db.vala:44: Creating database schema version %d for app version %s", DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION);
#line 46 "../src/db/Db.vala"
		_tmp5_ = version_table;
#line 46 "../src/db/Db.vala"
		version_table_set_version (_tmp5_, DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION, NULL);
#line 47 "../src/db/Db.vala"
		_tmp6_ = g_strdup (RESOURCES_APP_VERSION);
#line 47 "../src/db/Db.vala"
		_g_free0 (_vala_app_version);
#line 47 "../src/db/Db.vala"
		_vala_app_version = _tmp6_;
#line 48 "../src/db/Db.vala"
		_vala_schema_version = DATABASE_TABLE_SCHEMA_VERSION;
#line 339 "Db.c"
	} else {
#line 49 "../src/db/Db.vala"
		if (_vala_schema_version > DATABASE_TABLE_SCHEMA_VERSION) {
#line 51 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_FUTURE_VERSION;
#line 51 "../src/db/Db.vala"
			_database_table_unref0 (version_table);
#line 51 "../src/db/Db.vala"
			if (app_version) {
#line 51 "../src/db/Db.vala"
				*app_version = _vala_app_version;
#line 351 "Db.c"
			} else {
#line 51 "../src/db/Db.vala"
				_g_free0 (_vala_app_version);
#line 355 "Db.c"
			}
#line 51 "../src/db/Db.vala"
			if (schema_version) {
#line 51 "../src/db/Db.vala"
				*schema_version = _vala_schema_version;
#line 361 "Db.c"
			}
#line 51 "../src/db/Db.vala"
			return result;
#line 365 "Db.c"
		} else {
#line 52 "../src/db/Db.vala"
			if (_vala_schema_version < DATABASE_TABLE_SCHEMA_VERSION) {
#line 369 "Db.c"
				DbVerifyResult _result_ = 0;
#line 54 "../src/db/Db.vala"
				_result_ = db_upgrade_database (_vala_schema_version);
#line 55 "../src/db/Db.vala"
				if (_result_ != DB_VERIFY_RESULT_OK) {
#line 56 "../src/db/Db.vala"
					result = _result_;
#line 56 "../src/db/Db.vala"
					_database_table_unref0 (version_table);
#line 56 "../src/db/Db.vala"
					if (app_version) {
#line 56 "../src/db/Db.vala"
						*app_version = _vala_app_version;
#line 383 "Db.c"
					} else {
#line 56 "../src/db/Db.vala"
						_g_free0 (_vala_app_version);
#line 387 "Db.c"
					}
#line 56 "../src/db/Db.vala"
					if (schema_version) {
#line 56 "../src/db/Db.vala"
						*schema_version = _vala_schema_version;
#line 393 "Db.c"
					}
#line 56 "../src/db/Db.vala"
					return result;
#line 397 "Db.c"
				}
			}
		}
	}
#line 59 "../src/db/Db.vala"
	photo_table_clean_comments (&_inner_error0_);
#line 59 "../src/db/Db.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 59 "../src/db/Db.vala"
		_database_table_unref0 (version_table);
#line 59 "../src/db/Db.vala"
		_g_free0 (_vala_app_version);
#line 59 "../src/db/Db.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 59 "../src/db/Db.vala"
		g_clear_error (&_inner_error0_);
#line 59 "../src/db/Db.vala"
		return 0;
#line 416 "Db.c"
	}
#line 60 "../src/db/Db.vala"
	video_table_clean_comments (&_inner_error0_);
#line 60 "../src/db/Db.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 60 "../src/db/Db.vala"
		_database_table_unref0 (version_table);
#line 60 "../src/db/Db.vala"
		_g_free0 (_vala_app_version);
#line 60 "../src/db/Db.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 60 "../src/db/Db.vala"
		g_clear_error (&_inner_error0_);
#line 60 "../src/db/Db.vala"
		return 0;
#line 432 "Db.c"
	}
#line 63 "../src/db/Db.vala"
	result = DB_VERIFY_RESULT_OK;
#line 63 "../src/db/Db.vala"
	_database_table_unref0 (version_table);
#line 63 "../src/db/Db.vala"
	if (app_version) {
#line 63 "../src/db/Db.vala"
		*app_version = _vala_app_version;
#line 442 "Db.c"
	} else {
#line 63 "../src/db/Db.vala"
		_g_free0 (_vala_app_version);
#line 446 "Db.c"
	}
#line 63 "../src/db/Db.vala"
	if (schema_version) {
#line 63 "../src/db/Db.vala"
		*schema_version = _vala_schema_version;
#line 452 "Db.c"
	}
#line 63 "../src/db/Db.vala"
	return result;
#line 456 "Db.c"
}

DbVerifyResult
db_upgrade_database (gint input_version)
{
	gint version = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	FaceTable* _tmp5_;
	FaceTable* _tmp6_;
	FaceLocationTable* _tmp7_;
	FaceLocationTable* _tmp8_;
	VersionTable* _tmp11_;
	VersionTable* _tmp12_;
	GError* _inner_error0_ = NULL;
	DbVerifyResult result;
#line 67 "../src/db/Db.vala"
	_vala_assert (input_version < DATABASE_TABLE_SCHEMA_VERSION, "input_version < DatabaseTable.SCHEMA_VERSION");
#line 69 "../src/db/Db.vala"
	version = input_version;
#line 72 "../src/db/Db.vala"
	if (version == 1) {
#line 73 "../src/db/Db.vala"
		result = DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE;
#line 73 "../src/db/Db.vala"
		return result;
#line 484 "Db.c"
	}
#line 75 "../src/db/Db.vala"
	g_message ("Db.vala:75: Upgrading database from schema version %d to %d", version, DATABASE_TABLE_SCHEMA_VERSION);
#line 87 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "flags")) {
#line 88 "../src/db/Db.vala"
		g_message ("Db.vala:88: upgrade_database: adding flags column to PhotoTable");
#line 89 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "flags", "INTEGER DEFAULT 0")) {
#line 90 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 90 "../src/db/Db.vala"
			return result;
#line 498 "Db.c"
		}
	}
#line 93 "../src/db/Db.vala"
	version = 3;
#line 104 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "file_format")) {
#line 105 "../src/db/Db.vala"
		g_message ("Db.vala:105: upgrade_database: adding file_format column to PhotoTable");
#line 106 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "file_format", "INTEGER DEFAULT 0")) {
#line 107 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 107 "../src/db/Db.vala"
			return result;
#line 513 "Db.c"
		}
	}
#line 110 "../src/db/Db.vala"
	version = 4;
#line 117 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "title")) {
#line 118 "../src/db/Db.vala"
		g_message ("Db.vala:118: upgrade_database: adding title column to PhotoTable");
#line 119 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "title", "TEXT")) {
#line 120 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 120 "../src/db/Db.vala"
			return result;
#line 528 "Db.c"
		}
	}
#line 123 "../src/db/Db.vala"
	version = 5;
#line 130 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "backlinks")) {
#line 131 "../src/db/Db.vala"
		g_message ("Db.vala:131: upgrade_database: adding backlinks column to PhotoTable");
#line 132 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "backlinks", "TEXT")) {
#line 133 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 133 "../src/db/Db.vala"
			return result;
#line 543 "Db.c"
		}
	}
#line 136 "../src/db/Db.vala"
	version = 6;
#line 150 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "time_reimported")) {
#line 151 "../src/db/Db.vala"
		g_message ("Db.vala:151: upgrade_database: adding time_reimported column to PhotoT" \
"able");
#line 152 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "time_reimported", "INTEGER")) {
#line 153 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 153 "../src/db/Db.vala"
			return result;
#line 558 "Db.c"
		}
	}
#line 156 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "editable_id")) {
#line 157 "../src/db/Db.vala"
		g_message ("Db.vala:157: upgrade_database: adding editable_id column to PhotoTable");
#line 158 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "editable_id", "INTEGER DEFAULT -1")) {
#line 159 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 159 "../src/db/Db.vala"
			return result;
#line 571 "Db.c"
		}
	}
#line 162 "../src/db/Db.vala"
	version = 7;
#line 174 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "rating")) {
#line 175 "../src/db/Db.vala"
		g_message ("Db.vala:175: upgrade_database: adding rating column to PhotoTable");
#line 176 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "rating", "INTEGER DEFAULT 0")) {
#line 177 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 177 "../src/db/Db.vala"
			return result;
#line 586 "Db.c"
		}
	}
#line 186 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "metadata_dirty")) {
#line 187 "../src/db/Db.vala"
		g_message ("Db.vala:187: upgrade_database: adding metadata_dirty column to PhotoTa" \
"ble");
#line 188 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "metadata_dirty", "INTEGER DEFAULT 1")) {
#line 189 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 189 "../src/db/Db.vala"
			return result;
#line 599 "Db.c"
		}
	}
#line 192 "../src/db/Db.vala"
	version = 9;
#line 199 "../src/db/Db.vala"
	if (database_table_has_table ("VideoTable")) {
#line 199 "../src/db/Db.vala"
		_tmp0_ = !database_table_has_column ("VideoTable", "flags");
#line 608 "Db.c"
	} else {
#line 199 "../src/db/Db.vala"
		_tmp0_ = FALSE;
#line 612 "Db.c"
	}
#line 199 "../src/db/Db.vala"
	if (_tmp0_) {
#line 200 "../src/db/Db.vala"
		g_message ("Db.vala:200: upgrade_database: adding flags column to VideoTable");
#line 201 "../src/db/Db.vala"
		if (!database_table_add_column ("VideoTable", "flags", "INTEGER DEFAULT 0")) {
#line 202 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 202 "../src/db/Db.vala"
			return result;
#line 624 "Db.c"
		}
	}
#line 205 "../src/db/Db.vala"
	version = 10;
#line 212 "../src/db/Db.vala"
	if (!database_table_has_column ("EventTable", "primary_source_id")) {
#line 213 "../src/db/Db.vala"
		g_message ("Db.vala:213: upgrade_database: adding primary_source_id column to Even" \
"tTable");
#line 214 "../src/db/Db.vala"
		if (!database_table_add_column ("EventTable", "primary_source_id", "TEXT")) {
#line 215 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 215 "../src/db/Db.vala"
			return result;
#line 639 "Db.c"
		}
	}
#line 218 "../src/db/Db.vala"
	version = 11;
#line 225 "../src/db/Db.vala"
	if (!database_table_ensure_column ("TombstoneTable", "reason", "INTEGER DEFAULT 0", "upgrade_database: adding reason column to TombstoneTable")) {
#line 227 "../src/db/Db.vala"
		result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 227 "../src/db/Db.vala"
		return result;
#line 650 "Db.c"
	}
#line 230 "../src/db/Db.vala"
	version = 12;
#line 237 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "developer")) {
#line 238 "../src/db/Db.vala"
		g_message ("Db.vala:238: upgrade_database: adding developer column to PhotoTable");
#line 239 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "developer", "TEXT")) {
#line 240 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 240 "../src/db/Db.vala"
			return result;
#line 664 "Db.c"
		}
	}
#line 243 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "develop_shotwell_id")) {
#line 244 "../src/db/Db.vala"
		g_message ("Db.vala:244: upgrade_database: adding develop_shotwell_id column to Ph" \
"otoTable");
#line 245 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "develop_shotwell_id", "INTEGER DEFAULT -1")) {
#line 246 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 246 "../src/db/Db.vala"
			return result;
#line 677 "Db.c"
		}
	}
#line 249 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "develop_camera_id")) {
#line 250 "../src/db/Db.vala"
		g_message ("Db.vala:250: upgrade_database: adding develop_camera_id column to Phot" \
"oTable");
#line 251 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "develop_camera_id", "INTEGER DEFAULT -1")) {
#line 252 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 252 "../src/db/Db.vala"
			return result;
#line 690 "Db.c"
		}
	}
#line 255 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "develop_embedded_id")) {
#line 256 "../src/db/Db.vala"
		g_message ("Db.vala:256: upgrade_database: adding develop_embedded_id column to Ph" \
"otoTable");
#line 257 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "develop_embedded_id", "INTEGER DEFAULT -1")) {
#line 258 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 258 "../src/db/Db.vala"
			return result;
#line 703 "Db.c"
		}
	}
#line 261 "../src/db/Db.vala"
	version = 13;
#line 268 "../src/db/Db.vala"
	if (input_version < 14) {
#line 269 "../src/db/Db.vala"
		tag_table_upgrade_for_htags ();
#line 712 "Db.c"
	}
#line 271 "../src/db/Db.vala"
	version = 14;
#line 283 "../src/db/Db.vala"
	version = 15;
#line 293 "../src/db/Db.vala"
	if (input_version < 16) {
#line 296 "../src/db/Db.vala"
		gsettings_configuration_engine_run_gsettings_migrator ();
#line 722 "Db.c"
	}
#line 299 "../src/db/Db.vala"
	version = 16;
#line 306 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "comment")) {
#line 307 "../src/db/Db.vala"
		g_message ("Db.vala:307: upgrade_database: adding comment column to PhotoTable");
#line 308 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "comment", "TEXT")) {
#line 309 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 309 "../src/db/Db.vala"
			return result;
#line 736 "Db.c"
		}
	}
#line 311 "../src/db/Db.vala"
	if (database_table_has_table ("VideoTable") & (!database_table_has_column ("VideoTable", "comment"))) {
#line 312 "../src/db/Db.vala"
		g_message ("Db.vala:312: upgrade_database: adding comment column to VideoTable");
#line 313 "../src/db/Db.vala"
		if (!database_table_add_column ("VideoTable", "comment", "TEXT")) {
#line 314 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 314 "../src/db/Db.vala"
			return result;
#line 749 "Db.c"
		}
	}
#line 317 "../src/db/Db.vala"
	version = 17;
#line 324 "../src/db/Db.vala"
	if (!database_table_has_column ("EventTable", "comment")) {
#line 325 "../src/db/Db.vala"
		g_message ("Db.vala:325: upgrade_database: adding comment column to EventTable");
#line 326 "../src/db/Db.vala"
		if (!database_table_add_column ("EventTable", "comment", "TEXT")) {
#line 327 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 327 "../src/db/Db.vala"
			return result;
#line 764 "Db.c"
		}
	}
#line 330 "../src/db/Db.vala"
	version = 18;
#line 341 "../src/db/Db.vala"
	if (input_version < 19) {
#line 771 "Db.c"
		Application* _tmp1_;
		Application* _tmp2_;
#line 342 "../src/db/Db.vala"
		_tmp1_ = application_get_instance ();
#line 342 "../src/db/Db.vala"
		_tmp2_ = _tmp1_;
#line 342 "../src/db/Db.vala"
		application_set_raw_thumbs_fix_required (_tmp2_, TRUE);
#line 342 "../src/db/Db.vala"
		_application_unref0 (_tmp2_);
#line 782 "Db.c"
	}
#line 345 "../src/db/Db.vala"
	version = 19;
#line 355 "../src/db/Db.vala"
	version = 20;
#line 362 "../src/db/Db.vala"
	if (!database_table_ensure_column ("PhotoTable", "has_gps", "INTEGER DEFAULT -1", "upgrade_database: adding gps_lat column to PhotoTable")) {
#line 362 "../src/db/Db.vala"
		_tmp4_ = TRUE;
#line 792 "Db.c"
	} else {
#line 364 "../src/db/Db.vala"
		_tmp4_ = !database_table_ensure_column ("PhotoTable", "gps_lat", "REAL", "upgrade_database: adding gps_lat column to PhotoTable");
#line 796 "Db.c"
	}
#line 362 "../src/db/Db.vala"
	if (_tmp4_) {
#line 362 "../src/db/Db.vala"
		_tmp3_ = TRUE;
#line 802 "Db.c"
	} else {
#line 366 "../src/db/Db.vala"
		_tmp3_ = !database_table_ensure_column ("PhotoTable", "gps_lon", "REAL", "upgrade_database: adding gps_lon column to PhotoTable");
#line 806 "Db.c"
	}
#line 362 "../src/db/Db.vala"
	if (_tmp3_) {
#line 368 "../src/db/Db.vala"
		result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 368 "../src/db/Db.vala"
		return result;
#line 814 "Db.c"
	}
#line 371 "../src/db/Db.vala"
	version = 21;
#line 379 "../src/db/Db.vala"
	_tmp5_ = face_table_get_instance ();
#line 379 "../src/db/Db.vala"
	_tmp6_ = _tmp5_;
#line 379 "../src/db/Db.vala"
	_database_table_unref0 (_tmp6_);
#line 380 "../src/db/Db.vala"
	_tmp7_ = face_location_table_get_instance ();
#line 380 "../src/db/Db.vala"
	_tmp8_ = _tmp7_;
#line 380 "../src/db/Db.vala"
	_database_table_unref0 (_tmp8_);
#line 381 "../src/db/Db.vala"
	if (!database_table_has_column ("FaceLocationTable", "vec")) {
#line 382 "../src/db/Db.vala"
		g_message ("Db.vala:382: upgrade_database: adding vec column to FaceLocationTable");
#line 383 "../src/db/Db.vala"
		if (!database_table_add_column ("FaceLocationTable", "vec", "TEXT")) {
#line 384 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 384 "../src/db/Db.vala"
			return result;
#line 840 "Db.c"
		}
	}
#line 386 "../src/db/Db.vala"
	if (!database_table_has_column ("FaceLocationTable", "guess")) {
#line 387 "../src/db/Db.vala"
		g_message ("Db.vala:387: upgrade_database: adding guess column to FaceLocationTabl" \
"e");
#line 388 "../src/db/Db.vala"
		if (!database_table_add_column ("FaceLocationTable", "guess", "INTEGER DEFAULT 0")) {
#line 389 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 389 "../src/db/Db.vala"
			return result;
#line 853 "Db.c"
		}
	}
#line 391 "../src/db/Db.vala"
	if (!database_table_has_column ("FaceTable", "ref")) {
#line 392 "../src/db/Db.vala"
		g_message ("Db.vala:392: upgrade_database: adding ref column to FaceTable");
#line 393 "../src/db/Db.vala"
		if (!database_table_add_column ("FaceTable", "ref", "INTEGER DEFAULT -1")) {
#line 394 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 394 "../src/db/Db.vala"
			return result;
#line 866 "Db.c"
		}
	}
#line 397 "../src/db/Db.vala"
	version = 22;
#line 403 "../src/db/Db.vala"
	if (input_version < 23) {
#line 405 "../src/db/Db.vala"
		gsettings_configuration_engine_run_gsettings_migrator_v2 ();
#line 875 "Db.c"
	}
#line 408 "../src/db/Db.vala"
	version = 23;
#line 410 "../src/db/Db.vala"
	if (input_version < 24) {
#line 412 "../src/db/Db.vala"
		g_message ("Db.vala:412: upgrade_database: Shifting times from 0 to null for unset" \
" times");
#line 883 "Db.c"
		{
#line 414 "../src/db/Db.vala"
			photo_table_upgrade_for_unset_timestamp (&_inner_error0_);
#line 414 "../src/db/Db.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 414 "../src/db/Db.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 891 "Db.c"
					goto __catch0_database_error;
				}
#line 414 "../src/db/Db.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 414 "../src/db/Db.vala"
				g_clear_error (&_inner_error0_);
#line 414 "../src/db/Db.vala"
				return 0;
#line 900 "Db.c"
			}
#line 415 "../src/db/Db.vala"
			video_table_upgrade_for_unset_timestamp (&_inner_error0_);
#line 415 "../src/db/Db.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 415 "../src/db/Db.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 908 "Db.c"
					goto __catch0_database_error;
				}
#line 415 "../src/db/Db.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 415 "../src/db/Db.vala"
				g_clear_error (&_inner_error0_);
#line 415 "../src/db/Db.vala"
				return 0;
#line 917 "Db.c"
			}
#line 416 "../src/db/Db.vala"
			version = 24;
#line 921 "Db.c"
		}
		goto __finally0;
		__catch0_database_error:
		{
			GError* err = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 413 "../src/db/Db.vala"
			err = _inner_error0_;
#line 413 "../src/db/Db.vala"
			_inner_error0_ = NULL;
#line 418 "../src/db/Db.vala"
			_tmp9_ = err;
#line 418 "../src/db/Db.vala"
			_tmp10_ = _tmp9_->message;
#line 418 "../src/db/Db.vala"
			g_critical ("Db.vala:418: Failed to upgrade database to version 24: %s", _tmp10_);
#line 413 "../src/db/Db.vala"
			_g_error_free0 (err);
#line 941 "Db.c"
		}
		__finally0:
#line 413 "../src/db/Db.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 413 "../src/db/Db.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 413 "../src/db/Db.vala"
			g_clear_error (&_inner_error0_);
#line 413 "../src/db/Db.vala"
			return 0;
#line 952 "Db.c"
		}
	}
#line 422 "../src/db/Db.vala"
	_vala_assert (version == DATABASE_TABLE_SCHEMA_VERSION, "version == DatabaseTable.SCHEMA_VERSION");
#line 423 "../src/db/Db.vala"
	_tmp11_ = version_table_get_instance ();
#line 423 "../src/db/Db.vala"
	_tmp12_ = _tmp11_;
#line 423 "../src/db/Db.vala"
	version_table_update_version (_tmp12_, version, RESOURCES_APP_VERSION);
#line 423 "../src/db/Db.vala"
	_database_table_unref0 (_tmp12_);
#line 425 "../src/db/Db.vala"
	g_message ("Db.vala:425: Database upgrade to schema version %d successful", version);
#line 427 "../src/db/Db.vala"
	result = DB_VERIFY_RESULT_OK;
#line 427 "../src/db/Db.vala"
	return result;
#line 971 "Db.c"
}

